
/*
 * @(#)SharedDataObject.java	1.1 97/05/15
 *
 * Copyright (c) 1993-1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

package SharedData;

/**
 * Shared Data root class.
 *
 * @version     0.90 11 February 1997
 * @author      Rich Burridge
 */

public class
SharedDataObject implements SharedDataDebugFlags {

    /** The type of this implemention (socket, rmi, srm ...). */
    String connectType;


    public String
    getConnectionType() {
        if (SharedDataObject_Debug) {
            System.out.println("SharedDataObject: getConnectionType: " +
                               " type: " + connectType);
        }

        return(connectType);
    }


    public void
    setConnectionType(String connectType) {
        if (SharedDataObject_Debug) {
            System.out.println("SharedDataObject: setConnectionType: " +
                               " type: " + connectType);
        }

	this.connectType = connectType;
    }
}
