package webflow.modules.demo.ademo;

import java.io.*;
import java.net.*;
import java.lang.*;

public class AppletSocket implements Runnable{
Socket socket;

private Thread runner;
CommandInput1 filt;
plotframe1 pframe;
boolean bool;
DataOutputStream dos;
DataInputStream dis;
int Pt;
public AppletSocket(String Host,int port,plotframe1 pf ){
pframe=pf;
try{
  // module's socket
   socket=new Socket(Host,port);
   dos= new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
   }
catch(IOException e) {System.out.println(e);}

 filt=null;
 start();
}


public AppletSocket(Socket aSocket, CommandInput1 filter)
{
  //applet's socket
 filt=filter;
 socket=aSocket;
 start();
 try {
   dos= new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
 }
 catch(IOException e) {System.out.println(e);}
}



public void start()
{
    if(runner==null)
{
   runner= new Thread(this);
   runner.start();
}
}

  public void run(){
     if(filt!=null){
        while(true){
              String choice = receive();
	      filt.setValue(choice);
       }	
    }
    else{
       try{
            int flag=dis.readInt();
       }
       catch(IOException e){System.out.println(e);}
       filt.destroy();
     }
  }

  public void send(String message){

     System.out.println("WRITING MESSAGE: "+message);

     int sl = message.length();
     byte[] buf =new byte[sl];
     message.getBytes(0,sl,buf,0); 

       try{
           System.out.println("WRITING VALUES");
           dos.writeInt(sl);
           dos.write(buf,0,sl);
          } catch(IOException e) {System.out.println(e);}
}

     public String receive(){
     String message = "";
     System.out.println("READING MESSAGE: ");
     try{
       //        DataInputStream dis = new DataInputStream(socket.getInputStream());
        int ls=dis.readInt();
        byte buf[] = new byte[ls];
        dis.read(buf,0,ls);
        message = new String(buf,0,ls);
        System.out.println("I have received from Applet: "+message);
        } catch(IOException e){System.out.println(e);}
    return(message);
}

  
    
  public void stop(){
System.out.println("stopping APPLETSOCKET");
    if(runner!=null){
runner.stop();
runner=null;
try{
socket.close();
}catch(IOException e) {System.out.println(e);}
    }
  }
}




























