package webflow.appletsocket;

import java.io.*;
import java.net.*;
import java.lang.*;
import webflow.frontend.ModuleControls.*;

public class ClientSocket implements Runnable{

Socket socket;

private Thread runner;

controls applet;
String host;
int port;
DataOutputStream dos;
DataInputStream dis;
boolean flag;

public ClientSocket(controls applet, String host, int port)
{
  //client's socket

   this.applet = applet;
   System.out.println("new socket "+host+":"+port);
   this.host=host;
   this.port=port;
   flag=true;

   while(flag) {
     // wait till the parent module initializes and creates the server socket
     try {
          socket = new Socket(host,port);
          flag=false;
     }
   catch(IOException e) {;}
   }

 try {
   dos= new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
 }
 catch(IOException e) {System.out.println(e);}

   start();
}

public void start()
{
    if(runner==null)
{
   runner= new Thread(this);
   runner.start();
}
}

  public void run(){
     
 // send("_make_connection");

    /*
               while(true){
	               String message = receive();
		       //System.out.println("received: "+message);
               applet.update_value(message); 
       }
       */	
  }

  public void send(String message){

     System.out.println("socket send: "+message);
     int sl = message.length();
     byte[] buf =new byte[sl];
     message.getBytes(0,sl,buf,0); 

       try{
           dos.writeInt(sl);
           dos.write(buf,0,sl);
           dos.flush();
          } catch(IOException e) {System.out.println(e);}

}

     public String receive(){
     String message = "";
     System.out.println("socket trying to receive");
     try{
        int ls=dis.readInt();
        byte buf[] = new byte[ls];
        dis.read(buf,0,ls);
        message = new String(buf,0,ls);
        // System.out.println("I have received from Server: "+message);
        } catch(IOException e){
          System.out.println(e);
          stop();
        }
    return(message);
}

  
    
  public void stop(){
System.out.println("stopping ClientSocket");
    if(runner!=null){
runner.stop();
runner=null;
try{
socket.close();
}catch(IOException e) {System.out.println(e);}
    }
  }
}




























