package webflow.appletsocket;

import java.io.*;
import java.net.*;
import java.lang.*;
import webflow.modules.Templates.*;

public class ModuleSocket implements Runnable{

// this is a server socket
// to reuse this class update class name,
// and class name of the sever that uses this socket. 
// Here, the socket is used by myFrame created by PlotFrame
// The receive method makes use of the
// server's update_value(String message) method
 
Socket socket;
ServerSocket ss;

private Thread runner;

Template server;
DataOutputStream dos;
DataInputStream dis;

public ModuleSocket(Template server,int port) {
  //server socket

   this.server = server;
try{
   ss=new ServerSocket(port);
   int newport = ss.getLocalPort();
   System.out.println("register port "+newport);
   server.RegisterPort(newport);
   System.out.println("waiting for a client to connect on port "+newport);
   socket=ss.accept();
   System.out.println("client connected");
   dos= new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
   }
catch(IOException e) {System.out.println(e);}

 start();
}

public void start()
{
    if(runner==null)
{
   runner= new Thread(this);
   runner.start();
}
}

  public void run(){
        while(true){
	       String message = receive();
               server.update_value(message); 
       }	
  }

  public void send(String message){

     int sl = message.length();
     byte[] buf =new byte[sl];
     message.getBytes(0,sl,buf,0); 
     System.out.println("Trying to send... "+message);

       try{
           dos.writeInt(sl);
           dos.write(buf,0,sl);
           dos.flush();
          } catch(IOException e) {System.out.println(e);}
}

     public String receive(){
     String message = "";
     try{
        int ls=dis.readInt();
        byte buf[] = new byte[ls];
        dis.read(buf,0,ls);
        message = new String(buf,0,ls);
	//        System.out.println("I have received from Applet: "+message);
        } catch(IOException e){
          System.out.println(e);
          stop();
        }
    return(message);
}

   public int getPort(){
    return ss.getLocalPort();
   }
  
    
  public void stop(){
System.out.println("stopping ModuleSocket");
    if(runner!=null){
runner.stop();
runner=null;
try{
socket.close();
}catch(IOException e) {System.out.println(e);}
    }
  }
}




























