package webflow.backend;

import javax.servlet.*;
import java.net.*;
import java.util.*;
import java.io.*;

import webflow.frontend.*;

public class CreateModule extends GenericServlet{

String SMUrl;
/**
* Initialize the CreateModule Servlet with the Session Manager URL 
*
**/	
public void init(ServletConfig initialParameters)
       throws ServletException	
{
	//System.out.println("Going for Session Name");
	super.init(initialParameters);
	SMUrl = initialParameters.getInitParameter("SMUrl");

}

/**
* Service method is used to create a module and add it 
**/
public void service(ServletRequest req,ServletResponse res) 
	throws ServletException,IOException
{
	String fname=req.getParameter("fname");
	if(fname!=null)
	{
		service_command(req,res);
	}
}		
	

void service_command(ServletRequest req, ServletResponse res)
{
	DataInputStream dis;
	int numports=0;
	String FileName;
	res.setContentType("text/html");
	URL cgiurl;
	//InetAddress local = java.net.InetAddress.getLocalHost();
//System.out.println("Session5");
//String hostName = local.getHostName();
	String hostName = req.getServerName();
        int port     = req.getServerPort();
        //System.out.println("Server host ="+hostName+"Port = "+port);
        String urlstr=new String("http://"+hostName+":"+port+"/cgi-bin/compile.pl?SMUrl=");	
	urlstr+=SMUrl+"&fname=";
	//System.out.println("Got SMURL = " + urlstr);
	try
	{
	 OutputStream os = res.getOutputStream();
	 PrintStream out = new PrintStream(os);
	
	/** try to get the key from the request **/
	String command = req.getParameter("fname");
	//System.out.println("Got URL = " + command);
	urlstr+=command;	
	
	/** try to read the URL **/
	URL url = new URL(command);
	//System.out.println("Call CGI  URL = " + urlstr);
	FileName= url.getFile();
	//System.out.println("File Name  " + FileName);	
	dis= new DataInputStream(url.openStream());
        String projName;
	projName=dis.readLine(); //Skip Exe Name
        //System.out.println(projName);
	System.out.println(dis.readLine());	// Skip hpfPort
        urlstr+="&proj="+projName;
       //System.out.println("Okay Added Proj");
      urlstr+="&ports=";
	String ports = dis.readLine();
	urlstr+=ports;
	numports = Integer.parseInt(ports);
	//System.out.println(urlstr);
        
	int ColVal[];
	ColVal = new int[numports];
	for(int i=0;i<numports;i++)
	{
		String line=dis.readLine();
		urlstr+="&val"+i+"=";
		int pos=line.indexOf("WebFlow");
		urlstr+=(new Character(line.charAt(pos+8)).toString());
//		System.out.println(ColVal[i]);		
	}
       
	//System.out.println(urlstr);
//	System.out.println(SMUrl);
	cgiurl = new URL(urlstr);	
	DataInputStream dgi= new DataInputStream(cgiurl.openStream());
	System.out.println(dgi.readLine());
	dis.close();
	}catch(IOException e)
	{
	System.out.println(e);
	}
//	create_module(FileName,numports);
//	create_displaymodule(FileName,numports);

}
}

/***
**  Creates a module given the module name and the number of ports
** /

/*void create_module(String fname, int numports)
{
	DataInputStream dis;
	DataOutputStream dos;
	dis = new DataInputStream("template.tmp");
	File file = new File(new File("webflow/webflow/modules/demo/HPF/"),"HPF"+fname);
	
	dos = new DataOutputStream(new FileOutputStream(file));
	String line = dis.readLine();
	int pos,len ;
	while(line!=null){
		pos=-1;
		if(line.indexOf("$file")!=-1){
			pos = line.indexOf("$file");
			len= 5;
		}
		else if(line.indexOf("$ports")!=-1){
			pos = line.indexOf("$ports");
			len=6;
		}
		if(pos!=-1)
		{
			String tmp= line.substring(0,pos);
			tmp+=fname;
			tmp+=line.substring(pos+len);
			line = tmp;	
		}
		dos.println(line);
		line=dis.readLine();
	}				
	dos.close();
	dis.close();
}	*/	
	
/***
*** Create Display 
***/
/*
void create_displaymodule(String fname, int numports)
{
	DataInputStream dis;
	DataOutputStream dos,dos2;
	dis = new DataInputStream("webflow/webflow/frontend/WebRect.tmp");
	File file = new File(new File("webflow/webflow/frontend/"),fname+Integer.toString(numports));
	File modtxt = 	new File(new File("webflow/"),"modules.txt");
	dos = new DataOutputStream(new FileOutputStream(file));
	dos2 = new DataOutputStream(new FileOutputStream(modtxt));	
	dos2.println(SMURL+" webflow.modules.demo.HPF.HPF"+fname+" "+fname+Integer.toString(numports));
	dos.close();
	String line = dis.readLine();
	int pos,len ;
	while(line!=null){
		pos=-1;
		if(line.indexOf("$ports")!=-1){
			pos = line.indexOf("$ports");
			len=6;
		}
		if(pos!=-1)
		{
			String tmp= line.substring(0,pos);
			tmp+=fname;
			tmp+=line.substring(pos+len);
			line = tmp;	
		}
		dos.println(line);
		line=dis.readLine();
	}				
	dos.close();
	dis.close();
}	*/
		
