package webflow.backend;

import java.util.*;
import uci.graphedit.*;

/** This class is an abstraction of module as a member of the ModuleList */

public class ModuleListItem extends Object{

  protected String moduleName;
  protected String server;
  protected String moduleDescClass;
  
  /** Creates new ModuleListItem with given name, server and description
  *   of a module.
  */
  public ModuleListItem( String n, String s, String desc ){
    
    moduleName = new String(n);
    server = new String(s);
    moduleDescClass = new String( desc );

  }
  /** returns the name of the module. */
  public String getName(){ return moduleName; };

  /** returns the server on which the module is residing*/
  public String getServer(){ return server; }

  /** returns the class that represents the module.*/
  public String getModuleDescClass(){ return moduleDescClass; };

}/* End of class ModuleListItem */
