package webflow.frontend.ModuleControls; 

import com.sun.java.swing.JTextArea;

import com.sun.java.swing.JTree;
import com.sun.java.swing.tree.DefaultMutableTreeNode;
import com.sun.java.swing.JScrollPane;
import com.sun.java.swing.JPanel;
import com.sun.java.swing.JFrame;
import java.awt.GridLayout;
import java.awt.event.WindowListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;

import com.sun.java.swing.JLabel;
import com.sun.java.swing.JTextField;
import com.sun.java.swing.event.*;
import com.sun.java.swing.tree.*;



public class FilterPanel //implements ActionListener
{
  JLabel filterLable ;
  JTextField filterText;
  JTextField hostText,portText;
  DefaultMutableTreeNode top,rootNode ;
  String rootDir,relativeRootDir;
  DefaultMutableTreeNode stack[] = new DefaultMutableTreeNode[16];
  int  s_top=0;
  static JFrame frame;
  Panel p;
    
  public FilterPanel(Panel p_) 
  {
    p = p_;
    System.out.println("after setLayout in FilterPanel ");
  }
  
  public Panel fileBrowser()
  {
    actionPerformedX(p);
    System.out.println("after actionPerformedX in fileBrowser ");       
    return p;
    
  }
  

  public void FilterPanelX() 
  {
    
     p.setLayout(new GridLayout(3,1));
    
     filterLable = new JLabel ("Filter : ");
     p.add(filterLable);
     
     filterText = new JTextField("",30);
     p.add(filterText);

     //filterText.addActionListener(this);
   
     filterLable = new JLabel ("Host : ");
     p.add(filterLable);
     hostText = new JTextField("osprey3.npac.syr.edu",30);
     p.add(hostText);

     filterLable = new JLabel ("Port : ");
     p.add(filterLable);
     portText = new JTextField("5598",30);
     p.add(portText);
     
  }
  
 
  public DefaultMutableTreeNode findParent(String dirname)
  {
	 int ns=0;
	 String dirs[] = new String[16];
	 DefaultMutableTreeNode tnode=null;
	 
	 String si = dirname.substring(relativeRootDir.length());
	 
	 // get all the upper directory names
	 StringTokenizer st = new StringTokenizer(si,"/:",false);
         while(st.hasMoreTokens()){
	   dirs[ns] = st.nextToken();
	   System.out.println("/"+dirs[ns]);
	   
	   ns++;
	 }
         System.out.println("ndirs :"+ns);
	 

         tnode = stack[ns-1];
	 for(int i=0;i<tnode.getChildCount();i++){
	     TreeNode tn = tnode.getChildAt(i);
	     Object o = ((DefaultMutableTreeNode)tn).getUserObject();
	     TreeNodeInfo tinfo = (TreeNodeInfo)o;
	     if ((tinfo.permission.indexOf('d') == 0) &&
		 (tinfo.filename.equals(dirs[ns-1]))){
               System.out.println("I got dir name :"+tinfo.filename);
	       tnode = (DefaultMutableTreeNode)tn;
	       break;
	     }
	 }
	 s_top = ns;
	 stack[s_top++] = tnode;
  	 return tnode;
	 
  }
     
public void actionPerformed(ActionEvent e)
    {
      
    }
  

public void   actionPerformedX(Panel p)  
    {
      BufferedReader theHTML = null;
      URL url = null;
      String s;
      DefaultMutableTreeNode one;
      String host = "osprey3.npac.syr.edu";
      
      int   port = 5598;

      //System.out.println("Line entered :"+filterText.getText());
      System.out.println("Filter :/tmp");

      try{
	//url = new URL("http",hostText.getText(),
        //Integer.parseInt(portText.getText()),
	//		"/cgi-bin/readAllFiles.pl?"+filterText.getText());
	url = new URL("http",host,port,
		       "/cgi-bin/readAllFiles.pl?"+"/tmp");

	url.openConnection().setUseCaches(false);
	theHTML = new BufferedReader(new InputStreamReader(url.openStream()));
      }catch (MalformedURLException ev)
	{
          System.out.println("URL error in actionPerformed (run) " + ev);
	} 
      catch (IOException ev) 
	{
          System.out.println("IOException in actionPerformed (run)"+ev); 
        }
      try{
	s = theHTML.readLine();
	top = new DefaultMutableTreeNode(new TreeNodeInfo(s));
	System.out.println("rootDir "+s);
        rootDir = s;
        rootNode = top;
	stack[s_top++] = rootNode;
		
        s = theHTML.readLine();                 // read relative root directory
        relativeRootDir = s.substring(0,s.indexOf(':')); //remove last ':'
        s = theHTML.readLine();               // read string "total xxxx" 
	System.out.println("relativeRootDir "+relativeRootDir);

	while((s = theHTML.readLine()) != null) { 
          System.out.println("file "+s);
	  
          if ((s.length()) > 0){
	    TreeNodeInfo tn = new TreeNodeInfo(s);
            if (!((tn.filename.equals("."))||(tn.filename.equals(".."))))
	      top.add(one = new DefaultMutableTreeNode(tn));
 	  }
	  else{
	    System.out.println("null line\n");
	    s = theHTML.readLine(); // read next directory name
            top = findParent(s);
	    s = theHTML.readLine(); // read total xxx string
	  }
	  System.out.println("before loop ");
	}
	
      }catch (IOException ev) 
	{
          System.out.println("IOException in readLine()"+ev); 
        }

       System.out.println("end of performe ");

       final JTree tree = new JTree(rootNode);

     MouseListener ml = new MouseAdapter() {
     public void mouseClicked(MouseEvent e) {
         int selRow = tree.getRowForLocation(e.getX(), e.getY());
         TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
         if(selRow != -1) {
	       Dimension d =  tree.getParent().getParent().getSize();
             if(e.getClickCount() == 1) {
	       System.out.println("One Cliect pressed !!!");
	       //tree.getParent().getParent().getParent().repaint();
	       
                  //mySingleClick(selRow, selPath);
             }
             else if(e.getClickCount() == 2) {
 	         System.out.println("Two Cliect pressed !!!");
		 //tree.getParent().getParent().getParent().repaint();
		
                 //myDoubleClick(selRow, selPath);
             }
         }
      }
    };
     tree.addMouseListener(ml);

       //Create the scroll pane and add the tree to it. 
     JScrollPane scrollPane = new JScrollPane(tree);
     p.add(scrollPane);
          
   
       //frame.getContentPane().add("Center", scrollPane);
       //frame.show();

    }

     public static void main(String[] args) {
        /*
         * Create a window.  Use JFrame since this window will include 
         * lightweight components.
         */
        Panel panel;
       
        frame = new JFrame("TreeDemo");
       	
        WindowListener l = new WindowAdapter() {
	   public void windowClosing(WindowEvent e) {System.exit(0);}
        };
        frame.addWindowListener(l);

	Panel pt = new Panel();
	FilterPanel fp = new FilterPanel(pt);
        fp.fileBrowser();
	
        frame.getContentPane().add("Center",pt);
	frame.setSize(500, 500);
        frame.show();


	
    }
  
}


class TreeNodeInfo 
{
  String permission,ndirs,user,group,filesize,month,day,time,filename;
  int    nitems;
  
  public TreeNodeInfo (String fileInfo)
  {
    String tokens[] = new String[9];
    int i = 0;
    StringTokenizer st = new StringTokenizer(fileInfo," ",false);
    while(st.hasMoreTokens()){
      tokens[i] = st.nextToken();
      //System.out.println("next token "+tokens[i]);
      i++;
      
    }
    permission = tokens[0];
    ndirs      = tokens[1];
    user       = tokens[2];
    group      = tokens[3];
    filesize   = tokens[4];
    month      = tokens[5];
    day        = tokens[6];
    time       = tokens[7]; 
    filename   = tokens[8];
    if (i == 1) // directory name
      filename   = permission;
    nitems = i;
    
  }
  
  public String toString()
  {
    return filename;
  }
   
}
