package webflow.frontend.ModuleControls;
import webflow.appletsocket.*;

import com.sun.java.swing.JTextArea;
import com.sun.java.swing.JTree;
import com.sun.java.swing.tree.DefaultMutableTreeNode;
import com.sun.java.swing.JScrollPane;
import com.sun.java.swing.JPanel;
import com.sun.java.swing.JFrame;
import com.sun.java.swing.UIManager ;
import com.sun.java.swing.Icon ;
import com.sun.java.swing.JPopupMenu;
import com.sun.java.swing.JMenuItem;
import com.sun.java.swing.JMenu;
import com.sun.java.swing.SingleSelectionModel;
import com.sun.java.swing.DefaultCellEditor ;
import com.sun.java.swing.JComboBox;
import com.sun.java.swing.JLabel;
import com.sun.java.swing.AbstractListModel;
import com.sun.java.swing.ComboBoxModel;
import com.sun.java.swing.JButton;


import java.awt.GridLayout;
import java.awt.event.WindowListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;

import com.sun.java.swing.JLabel;
import com.sun.java.swing.JTextField;
import com.sun.java.swing.event.*;
import com.sun.java.swing.tree.*;
import com.sun.java.swing.ImageIcon;

import netscape.ldap.*;

public class MDSBrowser extends controls //extends JPanel
{
  
  String InitialRootDir="o=WebFlow,c=US";

  public void run(){}

public  ClientSocket waitUntilSocketReady()
  {
    while (socket == null) ;
    return socket;
 
  }

  public MDSBrowser (String host, int port) 
  {
    super(host,port);

    //this is  fixed WFEPort number
    port = 2424;
    System.out.println("MDSBrowser:host&port:"+host+":"+port);
    
    editFile      editOps = new editFile();
    FileTreeModel  root = new FileTreeModel(InitialRootDir,this);
    final DirTree tree = new DirTree(root,this);
    commandMenuItem commandMenu = new commandMenuItem (tree,root,
						       editOps,host,port);  
    tree.setCommandMenu(commandMenu);
    root.setCommandMenu(commandMenu);
    editOps.setCommandMenu(commandMenu);

    setLayout(new GridLayout(2,1));
    JPanel upperPanel = new JPanel();
    upperPanel.setLayout(new BorderLayout());
    JScrollPane scrollPane = new JScrollPane(tree);

    tree.addTreeExpansionListener(root);
    root.addTreeModelListener(tree);
    
    JPanel dnpanel = new JPanel();
    dnpanel.setLayout(new BorderLayout());
    JLabel label = new JLabel("Enter Base DN :");
    dnpanel.add(label,BorderLayout.NORTH);

    final selectedFile directory_field=new selectedFile(InitialRootDir,50,
					       	"directory",this);
    tree.addMouseListener(directory_field);
    directory_field.addActionListener(root);
    dnpanel.add(directory_field,BorderLayout.SOUTH);

    upperPanel.add(dnpanel,BorderLayout.NORTH);
    upperPanel.add(scrollPane,BorderLayout.CENTER);
    add(upperPanel);
    add(editOps);
    

    
  }
  
  
   public static void main(String[] args) {
        /*
         * Create a window.  Use JFrame since this window will include 
         * lightweight components.
         */
        
      JFrame frame = new JFrame("TreeDemo");
     	frame.getContentPane().setLayout( new BorderLayout() );
      WindowListener l = new WindowAdapter() {
     public void windowClosing(WindowEvent e) {System.exit(0);}
      };
      frame.addWindowListener(l);
		

      frame.getContentPane().add(BorderLayout.CENTER,new MDSBrowser(args[0],
      				   Integer.parseInt(args[1])));
      frame.setSize(600,600);
        //frame.move(60 + drawAreaSize.width, 10);frame.setSize(500, 500);
      frame.show();
    }
     
}


class selectedFile extends JTextField implements MouseListener,ActionListener
{
public String name;
public String fullFilePath;
MDSBrowser viewer;
  
public selectedFile(String text,int colums,String name_,MDSBrowser viewer_)
  {
    super(text,colums);
    name = name_;
    addActionListener(this);
    viewer = viewer_;
  }

 public void actionPerformed(ActionEvent e) {
   if (name.equals("file")){
     System.out.println("File :"+fullFilePath+" are sent in ActionPerformed!!!");
     //ClientSocket socket = viewer.waitUntilSocketReady() ;
     //socket.send("SWING_REPLY"+fullFilePath);
   }
 }
  

public void mouseClicked(MouseEvent e) {

  String dirName=null,fileName=null;
  
  //System.out.println("inside  selectedFile!!!");
  Component source = e.getComponent();
  DirTree tree = (DirTree)source;
  
  int selRow = tree.getRowForLocation(e.getX(), e.getY());
  TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
      
  if (selPath != null){
    
    fullFilePath = tree.getSelectedItem(selPath);
    System.out.println("inside  selectedFile:"+fullFilePath);

    int index = fullFilePath.lastIndexOf(",");
    fileName  = fullFilePath.substring(index+1);
    dirName   = fullFilePath.substring(0,index);
  
    if(selRow != -1) {
      if(e.getClickCount() == 1) {
	if (name.equals("file"))
	  setText(fileName);
	else if (name.equals("directory"))
	  setText(dirName);
      }
      else if(e.getClickCount() == 2) {
	if (name.equals("file"))
	  setText(fileName);
	else if (name.equals("directory"))
	  setText(dirName);

	if ((fileName.length() > 0)&&(name.equals("file"))){
	  System.out.println("File :"+fullFilePath+" are sent!!!");
	  //ClientSocket socket = viewer.waitUntilSocketReady() ;
	  //socket.send("SWING_REPLY"+fullFilePath);
	}
      }
    }
  }
  
}
  

 public void   mouseEntered(MouseEvent e) {;  }
     
 public void     mouseExited(MouseEvent e) {;  }
      
 public void     mousePressed(MouseEvent e) {;  }
      
 public void     mouseReleased(MouseEvent e) {;  }

  
}


class SomeTreeCellRenderer extends JLabel implements TreeCellRenderer
{
  DirTree tree;
  TreeCellRenderer treeCR;
  public boolean selected ;
    
public SomeTreeCellRenderer(DirTree tree_)
  {
     tree = tree_;
     treeCR = tree.getCellRenderer();
     
  }
  

public Component getTreeCellRendererComponent(JTree tree, Object value,
                                                  boolean sel,
                                                  boolean expanded,
                                                  boolean leaf, int row,
                                                  boolean hasFocus) 
  {
        String         stringValue = tree.convertValueToText(value, sel,
                                          expanded, leaf, row, hasFocus);

        setFont( tree.getFont() );
        setText(stringValue);
        if(sel)
            setForeground(UIManager.getColor("Tree.textSelectionColor"));
        else
	  setForeground(UIManager.getColor("Tree.textNonSelectionColor"));
	
        if (stringValue.length() == 0){
	  setIcon(new ImageIcon("emptyFolder.gif"));
	  //System.out.println("DUMMYNODE gif ");
	  
	}
        else if (leaf){
            setIcon(UIManager.getIcon("Tree.leafIcon"));
        } else if (expanded) {
            setIcon(UIManager.getIcon("Tree.openIcon"));
        } else {
            setIcon(UIManager.getIcon("Tree.closedIcon"));
        }
 
        selected = sel;
        return this;
    }

    public void paint(Graphics g) {
        Color bColor;
 
        if(selected) {
            bColor = UIManager.getColor("Tree.backgroundSelectionColor");
        } else {
            bColor = UIManager.getColor("Tree.backgroundNonSelectionColor");
            if(bColor == null)
                bColor = getBackground();
        }
        if(bColor != null) {
            Icon currentI = getIcon();
 
            g.setColor(bColor);
            if(currentI != null && getText() != null) {
                int offset = (currentI.getIconWidth() + getIconTextGap());
 
                g.fillRect(offset, 0, getWidth() - 1 - offset,
                           getHeight() - 1);
            } else {
	      g.fillRect(0, 0, getWidth()-1, getHeight()-1);
            }
        }
        if (selected) {
            g.setColor(UIManager.getColor("Tree.borderSelectionColor"));
            g.drawRect(0, 0, getWidth()-1, getHeight()-1);
        }
        super.paint(g);
    }
   
}




class DirTree extends JTree implements MouseListener,TreeModelListener
	
{
  JLabel filterLable ;
  JTextField filterText;
  JTextField hostText,portText;
  public DefaultMutableTreeNode top,rootNode ;
  public MDSBrowser viewer;
  commandMenuItem  commandMenu;

 public DirTree(FileTreeModel  root,MDSBrowser viewer_)
  {   
    setModel(root);
    viewer = viewer_;
    addMouseListener(this);
    setCellRenderer(new SomeTreeCellRenderer(this));
  }

public void setCommandMenu(commandMenuItem commandMenu_)
  {
   commandMenu = commandMenu_;
  }
  
public MDSBrowser getViewer()
  {
    return viewer;
        
  }
  

  public void mouseClicked(MouseEvent e) {

    //System.out.println("inside DIRTREE !!!");
    Component source = e.getComponent();
    int x = e.getX();
    int y = e.getY();
    
    DirTree tree = (DirTree)source;
    
    int selRow = tree.getRowForLocation(x,y);
    TreePath selPath = tree.getPathForLocation(x,y);
        
    if(selRow != -1) {
      if(e.getClickCount() == 1) {
      	//System.out.println("One Cliect pressed inside DIRTREE !!!");
	//mySingleClick(selRow, selPath);
      }
      else if(e.getClickCount() == 2) {
	//System.out.println("Two Cliect pressed inside DIRTREE !!!");
	//fireTreeExpanded(selPath);
      }
    }
  
  }

public String getSelectedItem(TreePath selPath)
  {
    if (selPath == null)
      return null;
    
    int pcount = selPath.getPathCount();
    TreeNode tn = (TreeNode)(selPath.getPathComponent(pcount-1));
    if (tn == null){
      System.out.println("pcount :"+pcount+" null");
      return null;
    }
    
    Object o = ((DefaultMutableTreeNode)tn).getUserObject();
    attributeVector tinfo = (attributeVector)o;
    String dn = (String)(tinfo.elementAt(0));
    //System.out.println("Selected dn : "+dn);
    return dn;
  }

public void   mouseEntered(MouseEvent e) {;  }
     
public void     mouseExited(MouseEvent e) {;  }
  
public void     mouseReleased(MouseEvent e) {;  }

public void mousePressed(MouseEvent e) 
  {
    Component source = e.getComponent();
    int x = e.getX();
    int y = e.getY();
    System.out.println("mouseClicked:x&y"+x+" "+y);

    //if user clicket third mouse button, open command PopupMenu
    if (e.getModifiers() == e.BUTTON3_MASK ) {
      System.out.println("mousePressed:BUTTON3_MASK pressed !!!");
      commandMenu.showPopupMenu(source,x,y);
    }
  }
  
public void   treeNodesChanged(TreeModelEvent e)
  {
    System.out.println("treeNodesChanged is CALLED !!! ");
    
  }
  

 public void    treeNodesInserted(TreeModelEvent e) 
{
    System.out.println(" treeNodesInserted  is CALLED !!! ");
    //setEditable(false);
  }
 public void    treeNodesRemoved(TreeModelEvent e) 
{
    System.out.println("treeNodesRemoved  is CALLED !!! ");
    
  }

 public void    treeStructureChanged(TreeModelEvent e)
 {
    System.out.println("treeStructureChanged  is CALLED !!! ");
    int row = getRowForPath(e.getTreePath());
    System.out.println("treeStructureChanged:row:"+row);
    //expandRow(row);

 }

 public void treeCollapsed(TreeExpansionEvent event)
  {
    //System.out.println("treeCollapsed is Called !!");
  }

public TreeNode lastOfPath()
{
  TreePath selPath = getSelectionPath();
  int pcount = selPath.getPathCount();
  TreeNode tn = (TreeNode)(selPath.getPathComponent(pcount-1));
  return tn;
  
}



}

class FileTreeModel extends DefaultTreeModel implements
      TreeExpansionListener,ActionListener
{
  
   MDSBrowser viewer;
   DefaultMutableTreeNode root;
   String LDAPServletHost;
   int LDAPServletPort;
   commandMenuItem commandMenu;
  
public FileTreeModel(String dirFullPath,MDSBrowser viewer_)
  {
    
    super(new DefaultMutableTreeNode(new attributeVector(".")));
    viewer = viewer_;
    root   = (DefaultMutableTreeNode)(getRoot());

    //updateTree(dirFullPath);
  }

  public void setCommandMenu(commandMenuItem commandMenu_)
  {
   commandMenu = commandMenu_;
  }

  public  DefaultMutableTreeNode findParent(attributeVector entry)
  {
	 int ns=0;
	 String dist_name,nexts,dirs[] = new String[16];
	 DefaultMutableTreeNode tnode=null;
	 Object obj;
	 attributeVector nextvec;
	 boolean flag=true;
	 String s,sstring;
	 	 	 
	
	 tnode = root;
	 obj = ((DefaultMutableTreeNode)tnode).getUserObject();
	 nextvec = (attributeVector)obj;
	 nexts = (String)(nextvec.elementAt(0));

	
	 dist_name = (String)(entry.elementAt(0));
	 //System.out.println("next :"+dist_name+" root="+nexts);
	 dist_name = dist_name.substring(0,dist_name.length()-
					 nexts.length()-1);

	 // get all the upper directory names
         StringTokenizer st = new StringTokenizer(dist_name,",",false);
         while(st.hasMoreTokens()){
           s = st.nextToken();
	   if (s.indexOf(' ') == 0)
	     s = s.substring(1);
	   dirs[ns] = s;
           //System.out.println("/"+dirs[ns]);
	   ns++;
	   
         }
	 ns--;
	 
	 while(ns > 0 ) {
	   sstring = dirs[ns]+","+nexts;
	   //System.out.println("ssstring "+sstring+" nchilds "+
      	   //   tnode.getChildCount()+" ns "+ns);
	   
	   for(int i=0;i<tnode.getChildCount();i++){
	     TreeNode tn = tnode.getChildAt(i);
	     obj = ((DefaultMutableTreeNode)tn).getUserObject();
	     attributeVector tinfo = (attributeVector)obj;
	     nexts = (String)(tinfo.elementAt(0));
	     //System.out.println("nexs in for "+nexts+" ssting "+sstring);
	     
	     if (nexts.equalsIgnoreCase(sstring)){
	       //System.out.println("I got dir name :"+nexts);
	       tnode = (DefaultMutableTreeNode)tn;
	       break;
	     }
	   }
	   ns--;
	 }
  	 return tnode;
	 
  }


public void actionPerformed(ActionEvent e) 
{
  String base = e.getActionCommand();
  System.out.println("ActionListener: directory name: "+base);
  root.removeAllChildren();
  updateTree(base);
  System.out.println("After updateTree");
  reload();
  System.out.println("ActionListener:inside FileTreeModel");
}
  
public  int  updateTree(String base)
{
  String s;
  DefaultMutableTreeNode parent=null;
     
  System.out.println("Filter :updateTree base "+base);
        
  attributeVector subtree =  commandMenu.getTree(base);
  //searchFull ("o=WebFlow,c=US", "objectclass=*");
  System.out.println("We will add "+subtree.size()+" entries !!!");

  attributeVector entry = (attributeVector)(subtree.elementAt(0));
  root.setUserObject(entry);
  
  for(int k=1;k<subtree.size();k++){
    entry = (attributeVector)(subtree.elementAt(k));
    parent = findParent(entry);
    parent.add(new DefaultMutableTreeNode(entry));  
  }
  return subtree.size();
}

public void getSelectedDirContent(TreePath selPath)
  {
    DefaultMutableTreeNode lastComponent = (DefaultMutableTreeNode)
                                           selPath.getLastPathComponent();
    TreeNode removedOne = lastComponent.getChildAt(0); 

    //Construct subtree
    String selectedDir = getSelectedItem(selPath);
    
    lastComponent.removeAllChildren();
    int childCnt = updateTree(selectedDir);
    	
    //announce dummy child is removed
    int[] childIndices = new int[1];
    childIndices[0] = 0;
    TreeNode[] removedChildren = new TreeNode[1];
    removedChildren[0] = removedOne;
    nodesWereRemoved((TreeNode)lastComponent,childIndices,
			  removedChildren);

    //announce some children added to current node	
    childIndices = new int[childCnt];
    for(int i=0;i<childCnt;i++) childIndices[i] = i;
    nodesWereInserted((TreeNode)lastComponent,childIndices);

  }
  
public String getSelectedItem(TreePath selPath)
  {
    int pcount = selPath.getPathCount();
    TreeNode tn = (TreeNode)(selPath.getPathComponent(pcount-1));
    Object o = ((DefaultMutableTreeNode)tn).getUserObject();
    attributeVector tinfo = (attributeVector)o;
    String dn = (String)(tinfo.elementAt(0));
    System.out.println("Selected dn : "+dn);
    return dn;
  }

public void treeExpanded(TreeExpansionEvent event)
  {
    //System.out.println("treeExpanded is Called !!");
  
    TreePath selPath = event.getPath();
    //System.out.println("selPath "+selPath.toString());
    //System.out.println("selPath count ="+selPath.getPathCount());
        
    String newDirName = getSelectedItem(selPath);
    //System.out.println("newDirName "+newDirName);
      
    if (newDirName.lastIndexOf("/") == newDirName.length() -1){
      getSelectedDirContent(selPath);
      //System.out.println("Getting Ne directory contents: "+newDirName);
    }
    
  }

public void treeCollapsed(TreeExpansionEvent event)
  {
    //System.out.println("treeCollapsed is Called !!");
  }


}

class attributeVector 
{
  Vector data;

  public attributeVector(Object obj)
  {
    data = new Vector();
    addElement(obj);
    
  }
  public attributeVector(Vector vector)
  {
    data = vector;
  } 

  public attributeVector()
  {
    data = new Vector();
  }
  
  public attributeVector(int elems)
  {
    data = new Vector(elems);
  }

  public Object elementAt(int index)
  {
    return data.elementAt(index);
  }
  
  public void addElement(Object item)
  {
    data.addElement(item);
  }

  public void add(int index,Object item)
  {
    data.insertElementAt(item,index);
  }

  public void setElementAt(Object item,int index)
  {
    data.setElementAt(item,index);
  }
  
public Object clone()
  {
    Vector vector = (Vector)data.clone();
    return new attributeVector(vector);
    
  }
  
public int size()
  {
    return data.size();
  }

public int indexOf(Object item)
  {
    return data.indexOf(item);
        
  }

public int indexOf(Object item,int index)
  {
    return data.indexOf(item,index);
        
  }  

  public String toString()
  {
    String name = (String)(data.elementAt(0));
    if (name.indexOf("DUMMYNODE")>=0)
      name = "          ";
    else if (name.indexOf(',') != name.lastIndexOf(',') )
      name = name.substring(0,name.indexOf(','));
    
    if (name.length() > 0){
      name = name.substring(name.indexOf("=")+1);
      name = name.trim();
    }
    return name;
  }
  
}


class commandMenuItem implements ActionListener
{
  JPopupMenu popmenu;
  DirTree tree;
  FileTreeModel treeModel;
  
  int nselection;
  WFLdapProxy LDAPproxy;
  String currentCommand="",previousCommand="";
  public editFile editOps;
  

  public commandMenuItem (DirTree tree_,FileTreeModel treeModel_,
	      editFile editOps_,String  LDAPServletHost, int LDAPServletPort)
  {
    
    tree = tree_;
    treeModel = treeModel_;
    editOps = editOps_;
        
    popmenu = new JPopupMenu("Commands");
    String[] labels = new String[] {"Open","Delete","Rename", 
				      "Cut", "Copy", "Paste" };
    String[] commands = new String[] { "open","delete","rename", 
					 "cut", "copy", "paste" };
    for(int i = 0; i < labels.length; i++) {
      JMenuItem mi = new JMenuItem(labels[i]);   // Create a menu item
      mi.setActionCommand(commands[i]);        // Set its action command
      mi.addActionListener(this);              // And its action listener
      popmenu.add(mi);                          // Add item to the popup menu
    }
    popmenu.addSeparator();
    
    JMenu newOption = new JMenu("New");
    JMenuItem mi = new JMenuItem("Folder"); 
    mi.setActionCommand("folder");        
    mi.addActionListener(this); 
    newOption.add(mi);

    mi = new JMenuItem("File"); 
    mi.setActionCommand("file");        
    mi.addActionListener(this); 
    newOption.add(mi);
    popmenu.add(newOption);      
   
    nselection = labels.length+1;
    LDAPproxy = new WFLdapProxy(this,tree_,treeModel_,editOps_,
			      LDAPServletHost,LDAPServletPort);
    LDAPproxy.connect();
    
  }
  
public String curCommand()
  {
    return currentCommand;
  }
  
public String prevCommand()
  {
    return previousCommand;
  }
  
  public void actionPerformed(ActionEvent event) {
    TreePath selectedPath = tree.getSelectionPath();
    if (selectedPath != null){
      String selectedDN = tree.getSelectedItem(selectedPath);
      System.out.println("Selected DN(actionPerformed) :"+selectedDN);
    }
    
      String command = event.getActionCommand();
      previousCommand = currentCommand;
      currentCommand = command;
      System.out.println("actionPerformed CALLED !!!:"+currentCommand);

      if (command.equals("delete")) {
	System.out.println("delete");
	LDAPproxy.deleteEntry();
      }
      
      else if (command.equals("cut")) {
	System.out.println("cut ");
	LDAPproxy.processCut();
      }
      
      else if (command.equals("copy")){
	System.out.println("Copy ");
	LDAPproxy.processCopy();
      }
      
      else if (command.equals("paste")) {
	System.out.println("paste ");
	LDAPproxy.processPaste();
      }
         
      else if (command.equals("open")){
	System.out.println("open");
	LDAPproxy.openFile();
      }
      else if (command.equals("rename")){
	System.out.println("rename");
	LDAPproxy.renameEntry();
      }
      
      else if (command.equals("folder")){
	System.out.println("folder");
	LDAPproxy.createDNEntry(LDAPproxy.NEWFOLDER);
      }
      
      else if (command.equals("file")) {
	System.out.println("file ");
        LDAPproxy.createDNEntry(LDAPproxy.NEWFILE);
      }
      
    }

public void showPopupMenu(Component comp,int x,int y)
  {
    System.out.println("showPopupMenu called!!");
    if (popmenu != null)
      System.out.println("popmenu OK !!"+popmenu);
    if (comp != null)
      System.out.println("comp OK !!"+comp);
    popmenu.show(comp,x,y);
  }
  
  public attributeVector getTree(String base)
  {
    return LDAPproxy.getTree(base);
  }

public void saveFile()
{
    LDAPproxy.saveFile();
}

public String openFile()
{
  return (LDAPproxy.openFile());
  
}

public boolean isFileChosed()
{
  return (LDAPproxy.isFileChosed());
}

public ClientSocket waitUntilSocketReady()
{
  ClientSocket socket = tree.getViewer().waitUntilSocketReady();
  return socket;
  
}


}



class WFLdapProxy  implements  CellEditorListener
{
  DirTree tree;
  FileTreeModel treeModel;
  commandMenuItem menu;
  
  public final static int SAVE      = 1;
  public final static int OPEN      = 2;
  public final static int DELETE    = 3;
  public final static int COPY      = 4;
  public final static int PASTE     = 5;
  public final static int CUT       = 6;
  public final static int NEWFILE   = 7;
  public final static int NEWFOLDER = 8;
  public final static int RENAME    = 9;
  public final static int GETTREE   = 10;
  
  public final static int WFEPort = 2424;
  public final static int ASCHILD = 0;
  public final static int ASBROTHER = 1;
  public final static int ASSELF = 2;

  public ObjectInputStream  ois;
  public ObjectOutputStream oos;
  public Socket LDAPServletSocket;
  public String LDAPServletHost="osprey4.npac.syr.edu";
  public int LDAPServletPort=2424;  
  public String [][]machineOrgPair;
  editFile editOps;
  

  DefaultMutableTreeNode  saveCopyNode,saveCutNode,saveNode;
  String saveNodeDN;
   
public WFLdapProxy(commandMenuItem menu_,DirTree tree_,
		   FileTreeModel treeModel_, editFile editOps_,
		   String  LDAPServletHost_, int LDAPServletPort_)
  {
    
    tree = tree_;
    treeModel = treeModel_;
    LDAPServletHost = LDAPServletHost_;
    LDAPServletPort =  LDAPServletPort_;
    menu = menu_;
    editOps = editOps_;
        
  }

public boolean isFileChosed()
{
  
  attributeVector atvec = nodeData(tree.lastOfPath());
  if ( atvec.indexOf("filename") < 0)
    return false;
  return true;
}

public String openFile()
  {
    TreePath selectedPath = tree.getSelectionPath();
    String selectedDN = tree.getSelectedItem(selectedPath);
    System.out.println("Selected DN :"+selectedDN);

    sendWFECommand(OPEN,selectedDN);
    String fileContent = (String)receiveWFECommandResult();
    editOps.setEditArea(fileContent);

    //set comboBox option
    TreeNode tn = (TreeNode)selectedPath.getLastPathComponent();
    attributeVector atvec = nodeData(tn);
    int siteIndex = atvec.indexOf("organization")+1;
    String site = (String)atvec.elementAt(siteIndex);
    int machineIndex = atvec.indexOf("machine")+1;
    String machine = (String)atvec.elementAt(machineIndex);
    editOps.setComboBox(site,machine);
    return fileContent;
    
  }

public void saveFile()
  {
     
    String []params = new String[4];
    TreePath selectedPath = tree.getSelectionPath();
    String fileDN = tree.getSelectedItem(selectedPath);
    System.out.println("fileDN(in saveFile) :"+fileDN );
    params[0] = fileDN;
    params[1] = editOps.getEditAreaContent();
    params[2] = editOps.getMachine();
    params[3] = editOps.getOrganization();
    
    sendWFECommand(SAVE,params);
    receiveWFECommandResult();
    
  }
  
  
public attributeVector getTree(String base)
  {
    //send the GETTREE command
    sendWFECommand(GETTREE,base);

    attributeVector mdsContent = new attributeVector();
    try{
      int isContinue = ois.readInt();
      while(isContinue != 0){
	attributeVector oneEntry = new attributeVector();
	/* Next directory entry */
	String newRDN = (String)receiveWFECommandResult();
	oneEntry.addElement(newRDN);
	System.out.println("newRDN :"+newRDN+"\n\n");
	 
	/* Get the attributes of the entry */
	isContinue = ois.readInt();
	while (isContinue != 0){
	  String attrName = (String)receiveWFECommandResult();
	  /* Loop on values for this attribute */
	  isContinue = ois.readInt();
	  
	  while ( isContinue != 0){
	    String aVal = (String)receiveWFECommandResult();
	    //insert attribute name and its value consequtively
	    //to make search attributes easily
	    oneEntry.addElement(attrName);
	    oneEntry.addElement(aVal);
	    isContinue = ois.readInt();
	  }
	  isContinue = ois.readInt();
	}
	mdsContent.addElement(oneEntry);
	isContinue = ois.readInt();
      }
      String []os       = (String[])receiveWFECommandResult();
      String []machines = (String[])receiveWFECommandResult();
      editOps.setComboBoxFields(machines,os);
    } catch( IOException e ) {
      System.out.println( "getTree:Error: " + e.toString() );
    }
    return mdsContent;
  }
    

public void sendWFECommand(int command,Object message)
  {
    try{
      oos.writeInt(command);
      oos.writeObject(message);
      oos.flush();
    }catch(OptionalDataException e){
      System.out.println("sendWFECommand "+e);
    }catch(IOException e){
      System.out.println("sendWFECommand "+e);
    }
    System.out.println("sendWFECommand :sent command for DN="+command);
    
  }

public void sendWFEMessage(Object message)
  {
    try{
      oos.writeObject(message);
      oos.flush();
    }catch(OptionalDataException e){
      System.out.println("sendWFECommand "+e);
    }catch(IOException e){
      System.out.println("sendWFECommand "+e);
    }
    System.out.println("sendWFECommand :sent message");
    
  }
  
public Object receiveWFECommandResult()
  {
    Object result=null;
    
    try{
      result = ois.readObject();
    }catch(OptionalDataException e){
      System.out.println("processWFECommand "+e);
    }catch(ClassNotFoundException e){
      System.out.println("processWFECommand "+e);
    }catch(IOException e){
      System.out.println("processWFECommand "+e);
    }
    System.out.println("I got result "+result);
    return result;
    
  }
  
public void connect()
  {
   
     try{
       LDAPServletSocket = new Socket( LDAPServletHost, LDAPServletPort);
       oos = new ObjectOutputStream(LDAPServletSocket.getOutputStream());
       ois = new ObjectInputStream(LDAPServletSocket.getInputStream());
     }catch(IOException e){
       System.out.println("connect:"+e);
     }
     System.out.println("I connected to:"+LDAPServletHost+
			" with port:"+LDAPServletPort);
      
 }

public attributeVector nodeData( TreeNode tn)
  
  {
    Object o = ((DefaultMutableTreeNode)tn).getUserObject();
    attributeVector tinfo = (attributeVector)o;
    String dn = (String)(tinfo.elementAt(0));
    System.out.println("Node Data(DN) : "+dn);
    return tinfo;
    
  }

public String getDN(TreeNode tn)
  {
    Object o = ((DefaultMutableTreeNode)tn).getUserObject();
    attributeVector tinfo = (attributeVector)o;
    String dn = (String)(tinfo.elementAt(0));
    return dn;
  }
  

public String createNewDN(DefaultMutableTreeNode tn,String editedValue,
			  int ChildOrBrother)
  {
    DefaultMutableTreeNode sibling=null;
    String origDN;
    
    if (ChildOrBrother == ASCHILD)
      sibling = (DefaultMutableTreeNode)tn.getParent();
    else if (ChildOrBrother == ASBROTHER)
      sibling  = tn.getPreviousSibling();
    else if (ChildOrBrother == ASSELF)
      sibling = tn;
     
    attributeVector tinfo  = nodeData(sibling);
    
    String dn = (String)(tinfo.elementAt(0));
    String firstRDN = dn.substring(0,dn.indexOf('='));
    int index = dn.indexOf(',');
    String dnPart = dn.substring(index+1).trim();
    if (ChildOrBrother == ASCHILD)
      dn = firstRDN+"="+editedValue+","+dn;
    else if ((ChildOrBrother == ASBROTHER)||
	     (ChildOrBrother == ASSELF))
      dn = firstRDN+"="+editedValue+","+dnPart;
    System.out.println("createNewDN :"+dn);
        
    return dn;
  }
  
public String makeCopyOfDN(String oldDN)
  {
    int colon      = oldDN.indexOf(",");
    String rest    = oldDN.substring(colon+1).trim();
    int equal      = oldDN.indexOf("=");
    String newVal  = "CopyOf "+oldDN.substring(equal+1,colon).trim();
    String attName = oldDN.substring(0,equal);
    String newEntryDN     = attName+"="+newVal+","+rest;
    System.out.println("makeCopyOfDN : "+newEntryDN);
    
    return  newEntryDN ;
  }

public String makeUnCopyOfDN(String oldDN)
  {
    int equal      = oldDN.indexOf("=");
    String rest    = oldDN.substring(equal+"CopyOf ".length()+1);
    String newDN   = oldDN.substring(0,equal+1)+rest;
    return newDN;
  }
  
public void createDNEntry(int folderOrFile )
  {
    DefaultMutableTreeNode lastInsertedNode = null;
    
    TreePath selPath = tree.getSelectionPath();
    saveNodeDN = tree.getSelectedItem(selPath);
    DefaultMutableTreeNode lastComponent = (DefaultMutableTreeNode)
                                           selPath.getLastPathComponent();
    saveNode = lastComponent;
    
    DefaultMutableTreeNode parent = (DefaultMutableTreeNode)
      lastComponent.getParent();
    //if user clicked the root node whose parent null
    //add new file as a child to the root
    if (parent == null)
      parent = lastComponent;
    int childOrder = parent.getChildCount() ;
    
    //attributeVector entry = new attributeVector(makeCopyOfDN(saveNodeDN));
    attributeVector entry = new attributeVector(saveNodeDN);
    lastInsertedNode = new DefaultMutableTreeNode(entry);
    parent.add(lastInsertedNode);
    System.out.println("I am adding the "+childOrder+"th child");

    //inform the LDAP server that I added the copy of clicked one
    System.out.println("I am making copy of folder"+saveNodeDN);
    //sendWFECommand(NEWFOLDER,saveNodeDN);
    //saveNodeDN = makeCopyOfDN(saveNodeDN);
    
    if (folderOrFile == NEWFOLDER)
      {
	//Insert empty node here to make this node folder
	entry = new attributeVector("          ");
	lastInsertedNode.add(new DefaultMutableTreeNode(entry));
      }
    
    //announce some children added to current node	
    int []childIndices = new int[1];
    childIndices[0] = childOrder;
    treeModel.nodesWereInserted(parent,childIndices);
    tree.setEditable(true);
    
    //get last node inserted and start editing it
    tree.startEditingAtPath(new TreePath(lastInsertedNode.getPath()));
    tree.getCellEditor().addCellEditorListener(this);

  }
 
public void renameEntry()
  {
    TreePath selPath = tree.getSelectionPath();
    saveNodeDN = tree.getSelectedItem(selPath);
    
    tree.setEditable(true);
    tree.startEditingAtPath(selPath);
    tree.getCellEditor().addCellEditorListener(this);
    
  }

public DefaultMutableTreeNode makeCopyOfTree(DefaultMutableTreeNode root)
  {
    DefaultMutableTreeNode save,cur=null,copy,rem,temp;
    Stack q = new Stack(),r = new Stack();

    Enumeration enum =  root.postorderEnumeration() ;

    if (root.isLeaf()){
      System.out.println("It is Leaf");
      copy = (DefaultMutableTreeNode)root.clone();
      copy.setUserObject(nodeData(copy).clone());
      return copy;
    }
    
    while(enum. hasMoreElements() )
      {
	save = cur;
	cur  = (DefaultMutableTreeNode)enum.nextElement();
        if (save == null)
	  save = cur;
	
	while (save.getParent() != cur)
	  {
	    save = cur;
	    cur  = (DefaultMutableTreeNode)enum.nextElement();
	    q.push(save);
	    r.push(save);
	  }
	System.out.println("Got Parent"+q.empty());
	rem = (DefaultMutableTreeNode)q.peek();
	System.out.println("rem :"+rem.toString());
	
	 copy = (DefaultMutableTreeNode)cur.clone();
	 copy.setUserObject(nodeData(copy).clone());
	 while((!q.empty()) &&
	       cur.isNodeChild((DefaultMutableTreeNode)q.peek())){
	   rem = (DefaultMutableTreeNode)r.pop();
	   if (rem.isLeaf()){
	     rem = (DefaultMutableTreeNode)(rem.clone());
	     rem.setUserObject(nodeData(rem).clone());
	   }
	   
	   copy.insert(rem,0);
	   q.pop();
	   System.out.println("Add:"+rem.toString()+" to:"+copy.toString());
	 	   
	 }
	 q.push(cur);
	 r.push(copy);
      }
    copy = (DefaultMutableTreeNode)r.pop();
    return copy;
    
  }

public String updateDN(TreeNode tn,String [][]pairs)
  {
    boolean flag=true;
    int start,end;
    
    //update root dn
    Object o = ((DefaultMutableTreeNode)tn).getUserObject();
    attributeVector tinfo = (attributeVector)o;
    String DN = (String)(tinfo.elementAt(0)); 
    for(int k=0;k<pairs.length;k++)
      {
	start = DN.indexOf(pairs[k][0]);
	if (start < 0)
	  continue;
        end = start+pairs[k][0].length()-1;
	DN = DN.substring(0,start)+pairs[k][1]+DN.substring(end+1);
      }
    return DN;
  }

public void replacePastedEntries(TreeNode root,String [][]pairs)
  {
    boolean flag=true;
    int index = 0,li=0;

    if ((root == null)||(pairs == null))
      return;
    
    attributeVector atvec = nodeData(root);
    System.out.println("replacePastedEntries :DN:"+getDN(root));
    
    //update root attributes;
    for(int k=0;k<pairs.length;k++)
      {
	while(flag){
	  li = atvec.indexOf(pairs[k][0],index);
	  if (li < 0)
	    break;
	  atvec.add(li,pairs[k][1]);
	  index = li+1;
	}
      }
    //update root dn
    atvec.add(0,updateDN(root,pairs));
    //finally update root node data record
    ((DefaultMutableTreeNode)root).setUserObject(atvec);
  
    Enumeration childs = root.children();
    while(childs.hasMoreElements())
      replacePastedEntries((TreeNode)childs.nextElement(),pairs);
  }

public String[][] findUnmatchedRDNs(String source,String target,
				    String editedValue)
  {
    StringTokenizer s,t;
    Vector  sv=new Vector(),tv=new Vector();
    String  ss,ts;
    int k;
      
    System.out.println("compare :"+source+" with :"+target);
    s = new StringTokenizer(source,",",false);
    t = new StringTokenizer(makeCopyOfDN(target),",",false);
    while((s.hasMoreTokens())&&(t.hasMoreTokens())){
      sv.addElement(s.nextElement());
      tv.addElement(t.nextElement());
    }
    //here you are trying to copy one entry to the place where
    //one doest have same parallel structure as source
    if ((s.hasMoreTokens()&&(!t.hasMoreTokens()))||
	(!s.hasMoreTokens()&&(t.hasMoreTokens())))
      return null;
        
    for(k=sv.size()-1;k>=0;k--)
      {
	ss = (String)sv.elementAt(k);
	ts = (String)tv.elementAt(k);
	if (!ss.equalsIgnoreCase(ts))
	  break;
      }
    //If two DN matched completely or 
    // only one mismatch with CUT(editedValue = null)
    if ((k < 0)||((k == 0)&&(editedValue==null)))
      return null;

    //If two DN did not matche
    int off = 0;
    int len = k+1;
    if (editedValue == null){
      len--;
      off = 1;
    }
    String [][]pairs = new String[len][2];
    pairs[0][0] = (String)sv.elementAt(0);
    int equal =  pairs[0][0].indexOf("=");
    if (editedValue != null)
      pairs[0][1] = pairs[0][0].substring(0,equal+1)+editedValue;
    System.out.println("Replace "+pairs[0][0]+" with "+ pairs[0][1]);
       
    for(int i=1;k>0;k--,i++){
      pairs[i-off][0] = (String)sv.elementAt(k);
      pairs[i-off][1] = (String)tv.elementAt(k);
      System.out.println("Replace "+pairs[i-off][0]+" with "+pairs[i-off][1]);
    }
    return pairs;
  }
  

public void processCut()
  {
    saveCutNode  = lastOfPath();
  }
  
public boolean DoesNodeHasThisChild( DefaultMutableTreeNode parent,
				     DefaultMutableTreeNode copy)
  {
    String copyDN = getDN(copy);
    Enumeration childs =   parent.children();
    while(childs.hasMoreElements()){
      TreeNode tn = (TreeNode)childs.nextElement();
      String oneDN = getDN(tn);
      if ((copyDN.equalsIgnoreCase(oneDN))&&
	  (tn != copy))
	return true;
    }
    return false;
        
  }
  
public void processCopy()
  {
    saveCopyNode  = makeCopyOfTree(lastOfPath());
    //update the RDN of root node
    //DefaultMutableTreeNode copy = saveCopyNode;
    //attributeVector atvec = nodeData(copy);
    //atvec.add(0,makeCopyOfDN(getDN(copy)));
    //copy.setUserObject(atvec);
    
  }

public void processPaste()
  {
    String source=null,target=null;
    
    int cutNodeOrder=-1,childOrder=-1;
    DefaultMutableTreeNode cutParent=null,copytoHere,parent;
    DefaultMutableTreeNode[] removedChildren = new DefaultMutableTreeNode[1];
    int []childIndices = new int[1];
    
    if (menu.prevCommand().equals("cut")){
      cutParent = (DefaultMutableTreeNode)saveCutNode.getParent();
      if (cutParent != null)
	cutNodeOrder = cutParent.getIndex(saveCutNode);
      else {
	System.out.println("CUT:You are trying to move parent to its child");
	return;
      }
      //You are trying to remove whole tree and 
      //paste it in one of its subtrees
      
    }
    
    copytoHere  = lastOfPath();
    parent = (DefaultMutableTreeNode)copytoHere.getParent();
    if (parent == null)
      parent = copytoHere;
    childOrder = parent.getChildCount() ;

    if (menu.prevCommand().equals("cut")){
      //You are trying to cut ascendant of "copytoHere"(saveCutNode)
      // , and paste it into one of its descendant nodes,copytoHere
      // In this case, just return
      if (saveCutNode.isNodeChild(copytoHere)){
	System.out.println("CUT:You try to cut ascendant of ");
	return ;
      }
      
      //If parent has same node with same DN, dont cut & paste to here
      if (DoesNodeHasThisChild(parent,saveCutNode)){
	System.out.println("CUT: no dublicate");
	return;
      }
      
      //remove the node first
      cutParent.remove(saveCutNode);
      //announce cut child is removed
      childIndices[0]    = cutNodeOrder;
      removedChildren[0] = saveCutNode;
      treeModel.nodesWereRemoved(cutParent,childIndices,removedChildren);

      //and add to the current location
      childIndices[0] = parent.getChildCount() ;
      source = getDN(saveCutNode);
      target = getDN(copytoHere);
      String[][] pairs = findUnmatchedRDNs(source,target,null);
      if (pairs == null)
	return;
      
      replacePastedEntries(saveCutNode,pairs);
      parent.add(saveCutNode);
      treeModel.nodesWereInserted(parent,childIndices);

      //inform to the LDAP server
      System.out.println("Source :"+source);
      String []msg = {source,target,"",menu.prevCommand() };
      sendWFECommand(PASTE,msg);
    }

    else if (menu.prevCommand().equals("copy")){
      parent.add(saveCopyNode);
      //announce some children added to current node	
      childIndices[0] = childOrder;
      treeModel.nodesWereInserted(parent,childIndices);
      treeModel.nodeStructureChanged(parent);

      //get last node inserted and start editing it
      tree.setEditable(true);
      tree.startEditingAtPath(new TreePath(saveCopyNode.getPath()));
      tree.getCellEditor().addCellEditorListener(this);
    }
}  


public void processCopyPaste(String editedValue)
  {
    String source,target;
    
    int childOrder;
    DefaultMutableTreeNode copytoHere,parent;
    int []childIndices = new int[1];
       
    copytoHere  = lastOfPath();
    copytoHere  = copytoHere.getPreviousSibling() ;
    parent = (DefaultMutableTreeNode)copytoHere.getParent();
    if (parent == null)
      parent = copytoHere;
    childOrder = parent.getChildCount()-1 ;

    source = getDN(saveCopyNode);
    target = getDN(copytoHere);
    String[][] pairs = findUnmatchedRDNs(source,target,editedValue);
    replacePastedEntries(saveCopyNode,pairs);
    
    //If parent has node with same DN, dont copy&paste to here
    if (DoesNodeHasThisChild(parent,saveCopyNode)){
      //get last node inserted and start editing it
      tree.setEditable(true);
      tree.startEditingAtPath(new TreePath(saveCopyNode.getPath()));
      tree.getCellEditor().addCellEditorListener(this);
      System.out.println("COPY:no dublicate");
      return;
    }
  
    //inform to the LDAP server
    System.out.println("Source :"+source);
    String []msg = {source,target,editedValue,menu.prevCommand() };
    sendWFECommand(PASTE,msg);
    

}  

public void deleteEntry()
  {
    DefaultMutableTreeNode parent,deletedNode;
    TreePath selPath = tree.getSelectionPath();
    deletedNode  = lastOfPath();
    saveNodeDN = tree.getSelectedItem(selPath);
    parent = (DefaultMutableTreeNode)deletedNode.getParent();
    int childIndex = parent.getIndex(deletedNode);
    parent.remove(childIndex);
    
    //announce dummy child is removed
    int[] childIndices = new int[1];
    childIndices[0] = childIndex;
    TreeNode[] removedChildren = new TreeNode[1];
    removedChildren[0] = deletedNode;
    treeModel.nodesWereRemoved(parent,childIndices,removedChildren);
  
    //inform the LDAP server that i deleted this node
    sendWFECommand(DELETE,saveNodeDN);
  }

  

public DefaultMutableTreeNode lastOfPath()
{
  TreePath selPath = tree.getSelectionPath();
  int pcount = selPath.getPathCount();
  TreeNode tn = (TreeNode)(selPath.getPathComponent(pcount-1));
  return (DefaultMutableTreeNode)tn;
  
}

public String makeNewRDN(String oldDN,String newRDNVal)
  {
    System.out.println("makeNewRDN: oldDN:"+oldDN+"  newRDNVal:"+ newRDNVal);
    
    int equal = oldDN.indexOf("=");
    String    firstAttName = oldDN.substring(0,equal);
    String newRDN = firstAttName+"="+newRDNVal;
    return newRDN;
  }

public String[] findChildrenDNs()
  {
    DefaultMutableTreeNode root;
    TreePath selPath = tree.getSelectionPath();
    root = (DefaultMutableTreeNode)selPath.getLastPathComponent();

    Enumeration childs =   root.postorderEnumeration();
    Vector list = new Vector();
    while(childs.hasMoreElements()){
      TreeNode tn = (TreeNode)childs.nextElement();
      String oneDN = getDN(tn);
      list.addElement(oneDN);
    }
    
    String []childrenDns = new String[list.size()];
    for(int k=0;k<list.size();k++)
      childrenDns[k] = (String)list.elementAt(k);
    return childrenDns;
  }

public void processNewFileFolder(String editedValue)
  {
    String source,target;
    
    int childOrder;
    DefaultMutableTreeNode copytoHere,parent;
    int []childIndices = new int[1];
       
    copytoHere  = lastOfPath();
    copytoHere  = copytoHere.getPreviousSibling() ;
    parent = (DefaultMutableTreeNode)copytoHere.getParent();
    if (parent == null)
      parent = copytoHere;
    childOrder = parent.getChildCount()-1 ;

    source = getDN(saveNode);
    target = getDN(copytoHere);
    String[][] pairs = findUnmatchedRDNs(source,target,editedValue);
    replacePastedEntries(copytoHere,pairs);
    
    //If parent has node with same DN, dont create new file/folder to here
    if (DoesNodeHasThisChild(parent,saveNode)){
      //get last node inserted and start editing it
      tree.setEditable(true);
      tree.startEditingAtPath(new TreePath(saveNode.getPath()));
      tree.getCellEditor().addCellEditorListener(this);
      System.out.println("NEWFILE:no dublicate");
      return;
    }
  
    //inform to the LDAP server
    System.out.println("Source :"+source);
    String []msg = {source,target,editedValue};
    sendWFECommand(NEWFILE,msg);
    

}  
  
public void editingStopped(ChangeEvent e)
{
  System.out.println("editingStopped  CALLED :"+menu.curCommand());
  System.out.println("editingStopped SaveNodeDN:"+saveNodeDN);
  
  //Get entered entry name in editing cell
  DefaultMutableTreeNode editedNode = lastOfPath();
  DefaultCellEditor s   = (DefaultCellEditor)e.getSource();
  String editedValue    = (String) s.getCellEditorValue();
  editedValue = editedValue.trim();
  System.out.println("editingStopped newValue:"+editedValue);
  String saveEditedValue  = editedValue;
  
  if (menu.curCommand().equals("paste")){
    processCopyPaste(saveEditedValue);
    //inform the viewer that this node structure changed
    tree.getCellEditor().removeCellEditorListener(this);
    tree.setEditable(false);
    treeModel.nodeChanged(editedNode);
    return;
  }
  

  //take copy his brother's data and modify only its DN part
  Object obj = editedNode.getUserObject();
  obj = ((attributeVector)obj).clone();
  attributeVector copyOfEditedNode = (attributeVector)obj;
  if (menu.curCommand().equals("rename"))
    editedValue = createNewDN(editedNode,editedValue,ASSELF);
  else
    editedValue = createNewDN(editedNode,editedValue,ASBROTHER);
  copyOfEditedNode.setElementAt(editedValue,0);
  editedNode.setUserObject(copyOfEditedNode);

  //if we created new folder,update inserted dummy node data
  if (menu.curCommand().equals("folder")){
    DefaultMutableTreeNode dummyChild = (DefaultMutableTreeNode)
                              editedNode.getChildAt(0);
    editedValue = createNewDN(dummyChild,"DUMMYNODE",ASCHILD);
    attributeVector entry = new attributeVector(editedValue);
    dummyChild.setUserObject(entry);
    treeModel.nodeChanged(dummyChild);
    System.out.println("dummy:"+editedValue);
      
  }
  
  //if we created new folder,update inserted dummy node data
  if ((menu.curCommand().equals("file"))||
      (menu.curCommand().equals("folder")))
    {
      processNewFileFolder(saveEditedValue);
    }
  else if (menu.curCommand().equals("rename"))
     {
      String[] command = new String[2];
      command[0] = saveNodeDN ;
      command[1] = makeNewRDN(saveNodeDN,saveEditedValue);
      System.out.println("Rename: "+command[0]+"&"+command[1]);
      sendWFECommand(RENAME,command);
    }
  //inform the viewer that this node structure changed
  tree.getCellEditor().removeCellEditorListener(this);
  tree.setEditable(false);
  treeModel.nodeChanged(editedNode);
}


public void editingCanceled(ChangeEvent e)
{
  System.out.println("editingCanceled  CALLED ");
}

}


class editFile extends JPanel implements ActionListener
{
public JComboBox machine;
public JComboBox organization;
public JButton saveButton;
public JButton submitButton;
public JTextArea editArea  ;
public commandMenuItem commandMenu;
  
public editFile() 
  {
        
    setLayout(new BorderLayout());
    
    JPanel commandPanel = new JPanel();
    commandPanel.setLayout(new FlowLayout());

    submitButton = new JButton("Submit");
    commandPanel.add(submitButton);

    saveButton = new JButton("Save");
    commandPanel.add(saveButton);
    
    commandPanel.add(new JLabel("Sites:"));
    organization = new JComboBox();
    organization.setEditable(true);
    commandPanel.add(organization);

    commandPanel.add(new JLabel("Machines:"));
    machine = new JComboBox();
    machine.setEditable(true);  
    commandPanel.add(machine);
    add(commandPanel,BorderLayout.NORTH);

    editArea = new JTextArea();
    add(new JScrollPane(editArea), BorderLayout.CENTER);   

    saveButton.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
       commandMenu.saveFile();
       System.out.println("selected in button :"+
			  (String)machine.getSelectedItem() );
       }
    });

    submitButton.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
      if (!commandMenu.isFileChosed()){
	System.out.println("You did not chose file");
	return;
      }
      
      if (getEditAreaContent().length() == 0)
	commandMenu.openFile();
      String fileContent = getEditAreaContent();
      System.out.println("submit file :"+ fileContent);
      ClientSocket socket = commandMenu.waitUntilSocketReady();
      socket.send("LDAPFile"+fileContent);
      setEditArea("") ;
      System.out.println("I submitted File ");
    }
    });
   
  }

public String getMachine()
  {
    String mname = (String)machine.getSelectedItem();
    return mname;
        
  }
  
public String getOrganization()
  {
    String oname = (String)organization.getSelectedItem();
    return oname;
  }
  
public String  getEditAreaContent()
  {
    return (editArea.getText());
  }
  

public void setEditArea(String data)
  {
    
    editArea.setText(data);
        
  }


public void setComboBox(String site,String parmachine)
  {
    organization.setSelectedItem(site); 
    machine.setSelectedItem(parmachine);
  }
     
 
public void setComboBoxFields(String[] ms,String[] os)
  {
    for(int k=0;(ms != null) && (k<ms.length);k++)
      machine.addItem(ms[k]);
    for(int k=0;(os != null) && (k<os.length);k++)
      organization.addItem(os[k]);
    
    machine.setSelectedIndex(0);
    organization.setSelectedIndex(0);
  }
  
 public void actionPerformed(ActionEvent e) 
{
  String cmnd = e.getActionCommand();
  System.out.println("ComboBox command:"+cmnd);
  System.out.println("selected in Combo :"+(String)machine.getSelectedItem() );
  
}

public void setCommandMenu(commandMenuItem commandMenu_)
  {
   commandMenu = commandMenu_;
  }
 
}









