// $Id: lowerPanel.java,v 1.4 1998/04/21 11:28:03 haupt Exp haupt $

package webflow.frontend.ModuleControls;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class lowerPanel extends Panel {

CardLayout card = new CardLayout();
controls[] modules;
String[] mnames;
int i,j;
public String host;
public int maxn;
  
public Hashtable ModuleNames;

 lowerPanel(int maxn, String host){

   super();
   this.maxn = maxn;
   System.out.println("maxn???? "+maxn);
   setLayout(card);
   this.host = host;
   modules = new controls[maxn];

   ModuleNames = new Hashtable(maxn);
   ModuleNames.put("Template1out",new Integer(1));
   ModuleNames.put("EditFile", new Integer(2));
   ModuleNames.put("FileBrowser",new Integer(3));
   ModuleNames.put("GRAM", new Integer(4));
   ModuleNames.put("FileName",new Integer(5));
   ModuleNames.put("GetFile",new Integer(6));
   ModuleNames.put("PutFile",new Integer(7));
   ModuleNames.put("newFTP",new Integer(7));
   ModuleNames.put("CERIUS2",new Integer(8));
   ModuleNames.put("GAUSSIAN",new Integer(9));
   ModuleNames.put("newGAUSSIAN",new Integer(9));
   ModuleNames.put("GAMESS",new Integer(10));
   ModuleNames.put("GAUS2PDB",new Integer(11));
   ModuleNames.put("newGAUS2PDB",new Integer(11));
   ModuleNames.put("writeFile",new Integer(12));
   }

  public void  showContents() {
   System.out.println("ShowContents called...");
   card.last(this);
   }

  public void  showContents(String what) {
   System.out.println("ShowContents called..."+what);
   card.show(this,what);
   }

  public void clean() {
    int i;
    for (i=0;i<maxn;i++) {
      if(modules[i] != null) {
        System.out.println("stop module "+i);
	modules[i].stop();
        modules[i]=null;
      }
    }
    removeAll();
  }
  

  public void addcard(String what, int n, int k) {
    System.out.println("addcard "+what+" as card no. "+n+" for controls "+k);
    System.out.println("Server: "+host);
    
    int port = 0;  

    switch(k) {
    case 1:
       modules[n] = new controls1(host,port);
       break;
    case 2:
       modules[n] = new controls2(host, port);
       break;
    case 3:
       modules[n] = new controls3(host,port);
       break;
    case 4:
       modules[n] = new controls4(host,port);
       break;
    case 5:
       modules[n] = new controls5(host,port);
       break;
    case 6:
       modules[n] = new controls6(host,port);
       break;
    case 7:
        modules[n] = new controls7(host,port);
       break;
    case 8:
        modules[n] = new controls8(host,port);
       break;
    case 9:
        modules[n] = new controls9(host,port);
       break;
    case 10:
       modules[n] = new controls10(host,port);
       break;
    case 11:
       modules[n] = new controls11(host,port);
        break;
    case 12:
       modules[n] = new controls12(host,port);
        break;
	/*
    case 13:
       modules[n] = new controls13(host,port);
        break;
    case 14:
       modules[n] = new controls14(host,port);
        break;
	*/
    default:
       modules[n] = new controls0();
       System.out.println("card "+n+" with no controls");
    }
    System.out.println("card name is now "+what);
    add(what,modules[n]);
    System.out.println("end of card add ");
  }
}




