package webflow.frontend.ModuleControls;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.util.zip.*;

public class plotframe extends Frame implements Runnable, ActionListener,
WindowListener
{

 private Thread runner;
 public final lowerPanel lp;
 Panel upperPanel;
 Button[] buttons;
 String[] bnames;
 ActionListener[] listeners;
 Menu menusave, menuload;
 MenuItem[] ss,sl;
 int i,j;
 GridLayout myLayout;
 Label lab;

 public plotframe(int maxn)
 {
 super("module panel");

  setLayout(new GridLayout(2,1));

  setSize(250,700);

 lp = new lowerPanel(maxn);
 upperPanel = new Panel();

 myLayout = new GridLayout(maxn,1);
 upperPanel.setLayout(myLayout);
 lab = new Label("Active Modules",Label.CENTER);
 lab.setFont(new Font("Serif",Font.BOLD,14));
 lab.setForeground(Color.blue);
 lab.setBackground(Color.yellow);
 upperPanel.add(lab);
 buttons = new Button[maxn];
 bnames = new String[maxn];
 listeners = new ActionListener[maxn];

 add(lp);
 add(upperPanel);

 this.addWindowListener(this);  
   show();
 start();
}

 public plotframe(int m, int maxn, String mname)
 {
 super("module panel");

  setLayout(new GridLayout(2,1));

  setSize(250,700);

 lp = new lowerPanel(m,maxn,mname);
 upperPanel = new Panel();

 myLayout = new GridLayout(maxn+1,1);
 upperPanel.setLayout(myLayout);
 upperPanel.add(new Label("Active Modules",Label.CENTER));
 buttons = new Button[maxn];
 bnames = new String[maxn];
 listeners = new ActionListener[maxn];

 bnames[0] = mname;
 buttons[0] = new Button(bnames[0]);
 listeners[0] = new ActionListener() {
    public void actionPerformed(ActionEvent e) {
          String what= e.getActionCommand().toString();
	  lp.showContents(what);
    }
  };
 buttons[0].addActionListener(listeners[0]);
 upperPanel.add(buttons[0]);

 add(lp);
 add(upperPanel);

 this.addWindowListener(this);  
   show();
 start();
}


 public void run(){}

public void start(){
    if(runner==null){
runner=new Thread(this);
runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
    runner.stop();
    runner=null;
    }
  }


public void killThisFrame() {this.dispose(); System.exit(0);}

public void windowClosing(WindowEvent e) {this.dispose(); System.exit(0);}
public void windowOpened(WindowEvent e) {;}
public void windowClosed(WindowEvent e) {;}
public void windowIconified(WindowEvent e) {System.out.println("WINDOW ICONIFIED");}
public void windowDeiconified(WindowEvent e) {;}
public void windowActivated(WindowEvent e) {;}
public void windowDeactivated(WindowEvent e) {;}
public void actionPerformed(ActionEvent e) {;}


public void addNewModule(int maxn, int n, int m, String mname) {

 int iadd;
 int n1=n-1;
 bnames[n1]=mname;
 buttons[n1]= new Button(bnames[n1]);
 listeners[n1] = new ActionListener() {
    public void actionPerformed(ActionEvent e) {
          String what= e.getActionCommand().toString();
	  lp.showContents(what);
    }
  };
 buttons[n1].addActionListener(listeners[n1]);
 
 remove(upperPanel);
 upperPanel = new Panel(myLayout);
 // upperPanel.setLayout();
 upperPanel.add(lab);

 System.out.println(n+" "+n1+" "+maxn);
 for(iadd=0;iadd<n;iadd++){
 upperPanel.add(buttons[iadd]);
 }

 add(upperPanel);
 lp.addcard(bnames[n1],m);
 show();

}

}
