package webflow.frontend.ModuleControls; 

import webflow.appletsocket.*;

import com.sun.java.swing.JTextArea;

import com.sun.java.swing.JTree;
import com.sun.java.swing.tree.DefaultMutableTreeNode;
import com.sun.java.swing.JScrollPane;
import com.sun.java.swing.JPanel;
import com.sun.java.swing.JFrame;
import java.awt.GridLayout;
import java.awt.event.WindowListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Enumeration;
import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;

import com.sun.java.swing.JLabel;
import com.sun.java.swing.JTextField;
import com.sun.java.swing.event.*;
import com.sun.java.swing.tree.*;



public class controls5 extends controls //implements ActionListener
{
  JLabel filterLable ;
  JTextField filterText;
  JTextField hostText,portText;
  DefaultMutableTreeNode top,rootNode ;
  String rootDir,relativeRootDir;
  DefaultMutableTreeNode stack[] = new DefaultMutableTreeNode[16];
  int  s_top=0;
  static JFrame frame;
  Panel p;

  public void run(){}
  
  public controls5 (String host, int port) 
  {
    super(host,port);  
    FileTreeModel  root = new FileTreeModel("/tmp",socket);
    
    refreshFileBrowser(root );
  }

public void refreshFileBrowser(FileTreeModel  root)
  {
    
    //remove all the components inside the Panel
    removeAll();
    
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    setFont(new Font("Helvetica", Font.PLAIN, 14));
    setLayout(gridbag);

    selectedFile file_field = new selectedFile("/tmp",50,"file");
    
    DirTree tree = new DirTree(root,this);
    JScrollPane scrollPane = new JScrollPane(tree);
    tree.addMouseListener(file_field);
    tree.addTreeExpansionListener(root);
    root.addTreeModelListener(tree);
       
    c.fill = GridBagConstraints.HORIZONTAL;
    c.gridwidth = GridBagConstraints.REMAINDER;

     //Next row
    JLabel label = new JLabel("Enter Path and Folder Name :");
    gridbag.setConstraints(label, c);
    add(label);

    final selectedFile directory_field = new selectedFile("",50,
							  "directory");
    tree.addMouseListener(directory_field);
    
    directory_field.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
      String dirname = directory_field.getText();
      System.out.println("ActionListener: directory name: "+dirname);
      FileTreeModel  new_root = new FileTreeModel(dirname,socket);
      refreshFileBrowser(new_root);
      getParent().show();
      System.out.println("ActionListener:Why Refreshing !!!! inside directory_field");
      }
    });
    gridbag.setConstraints(directory_field, c);
    add(directory_field);

    c.fill = GridBagConstraints.BOTH;
    c.weightx = 1.0;
    c.weighty = 1.0;

    c.gridheight = 2;
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(scrollPane, c);
    add(scrollPane);

    //Next row
    c.weightx = 0.0;
    c.weighty = 0.0;
    c.fill = GridBagConstraints.HORIZONTAL;
    label = new JLabel("Enter File Name :");
    gridbag.setConstraints(label, c);
    add(label);

    gridbag.setConstraints(file_field, c);
    add(file_field);

    c.fill = GridBagConstraints.NONE;

    //Next Row 
    c.fill = GridBagConstraints.NONE;
    Button button = new Button("OK");
    c.gridwidth = GridBagConstraints.RELATIVE;
    gridbag.setConstraints(button, c);
    add(button);
    button.addActionListener(file_field);
    

    button = new Button("Cancel");
    c.gridwidth = GridBagConstraints.REMAINDER;
    gridbag.setConstraints(button, c);
    add(button);
    
  }
  

  
     public static void main(String[] args) {
        /*
         * Create a window.  Use JFrame since this window will include 
         * lightweight components.
         */
        Panel panel;
       
        Frame frame = new Frame("TreeDemo");
       	frame.setLayout( new BorderLayout() );
        WindowListener l = new WindowAdapter() {
	   public void windowClosing(WindowEvent e) {System.exit(0);}
        };
        frame.addWindowListener(l);
		
        frame.add(BorderLayout.CENTER, new controls5("444",8));
	frame.pack();
        //frame.move(60 + drawAreaSize.width, 10);frame.setSize(500, 500);
        frame.show();
    }
     
}


class selectedFile extends JTextField implements MouseListener,ActionListener
{
public String name;
public String fullFilePath;
  
public selectedFile(String text,int colums,String name_)
  {
    super(text,colums);
    name = name_;
    addActionListener(this);
    
  }

 public void actionPerformed(ActionEvent e) {
   System.out.println("File :"+fullFilePath+" are sent in ActionPerformed!!!");
 }
  

public void mouseClicked(MouseEvent e) {

  String dirName=null,fileName=null;
  
  System.out.println("inside  selectedFile!!!");
  Component source = e.getComponent();
  DirTree tree = (DirTree)source;
  
  int selRow = tree.getRowForLocation(e.getX(), e.getY());
  TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
      
  if (selPath != null){
    
    fullFilePath = tree.getSelectedItem(selPath);
    int index = fullFilePath.lastIndexOf("/");
    fileName  = fullFilePath.substring(index+1);
    dirName   = fullFilePath.substring(0,index);
  
    if(selRow != -1) {
      if(e.getClickCount() == 1) {
	System.out.println("One Cliect pressed inside selectedfile !!!");
	if (name.equals("file"))
	  setText(fileName);
	else if (name.equals("directory"))
	  setText(dirName);
      }
      else if(e.getClickCount() == 2) {
	System.out.println("Two Cliect pressed inside selectedfile !!!");
	if (name.equals("file"))
	  setText(fileName);
	else if (name.equals("directory"))
	  setText(dirName);

	if ((fileName.length() > 0)&&(name.equals("file"))){
	  System.out.println("File :"+fullFilePath+" are sent!!!");
	}
      }
    }
  }
  
}
  

 public void   mouseEntered(MouseEvent e) {;  }
     
 public void     mouseExited(MouseEvent e) {;  }
      
 public void     mousePressed(MouseEvent e) {;  }
      
 public void     mouseReleased(MouseEvent e) {;  }

  
}



class DirTree extends JTree implements MouseListener,TreeModelListener
{
  JLabel filterLable ;
  JTextField filterText;
  JTextField hostText,portText;
  public DefaultMutableTreeNode top,rootNode ;
  String rootDir,relativeRootDir;
  DefaultMutableTreeNode stack[] = new DefaultMutableTreeNode[16];
  int  s_top=0;
  static JFrame frame;
  Panel p;
  public controls5 viewer;
  DataInputStream dis;
  DataOutputStream dos;
  
  
 public DirTree(DefaultTreeModel  root,controls5 viewer_)
  {
    super(root);
    addMouseListener(this);
    viewer = viewer_;
  }

    


  public void mouseClicked(MouseEvent e) {

    System.out.println("inside DIRTREE !!!");
    Component source = e.getComponent();
    DirTree tree = (DirTree)source;
  
    int selRow = tree.getRowForLocation(e.getX(), e.getY());
    TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
    if(selRow != -1) {
      if(e.getClickCount() == 1) {
	System.out.println("One Cliect pressed inside DIRTREE !!!");
	//mySingleClick(selRow, selPath);
      }
      else if(e.getClickCount() == 2) {
	System.out.println("Two Cliect pressed inside DIRTREE !!!");
	fireTreeExpanded(selPath);
      }
    }
  
  }
public String getSelectedItem(TreePath selPath)
  {
    int pcount = selPath.getPathCount();
    Object pathComponent =  selPath.getPathComponent(pcount-1);
    
   
    String fullPath="";
    for(int i=0;i<pcount;i++){
      TreeNode tn = (TreeNode)(selPath.getPathComponent(i));
      Object o = ((DefaultMutableTreeNode)tn).getUserObject();
      TreeNodeInfo tinfo = (TreeNodeInfo)o;

      String append = "";
      if ((tinfo.permission.indexOf('d') == 0)||((pcount>1)&&(i==0)))
	append = "/";
      fullPath += tinfo.toString()+append;
    }
    
    return fullPath;
  }

 public void   mouseEntered(MouseEvent e) {;  }
     
 public void     mouseExited(MouseEvent e) {;  }
      
 public void     mousePressed(MouseEvent e) {;  }
      
 public void     mouseReleased(MouseEvent e) {;  }
 

public void   treeNodesChanged(TreeModelEvent e)
  {
    System.out.println("treeNodesChanged is CALLED !!! ");
    
  }
  

 public void    treeNodesInserted(TreeModelEvent e) 
{
    System.out.println(" treeNodesInserted  is CALLED !!! ");
    
  }
 public void    treeNodesRemoved(TreeModelEvent e) 
{
    System.out.println("treeNodesRemoved  is CALLED !!! ");
    
  }

 public void    treeStructureChanged(TreeModelEvent e)
 {
    System.out.println("treeStructureChanged  is CALLED !!! ");
    int row = getRowForPath(e.getTreePath());
    System.out.println("treeStructureChanged:row:"+row);
    //expandRow(row);
    
    
 }      
}




class FileTreeModel extends DefaultTreeModel implements  TreeExpansionListener
{
  ClientSocket socket;
  
public FileTreeModel(String dirFullPath, ClientSocket socket_ )
  {
    super(constructTree(dirFullPath,socket_));
    socket = socket_;
    
  }
  
     
  public static DefaultMutableTreeNode   constructTree(String dirFullPath,
					  ClientSocket socket )  
    {
      BufferedReader theHTML = null;
      URL url = null;
      String s;
      DefaultMutableTreeNode top=null,one=null;
      String host = "osprey3.npac.syr.edu";
      int   port = 1242;

      System.out.println("Filter :/tmp");
      try{
	url = new URL("http",host,port,
		       "/cgi-bin/readAllFiles.pl?"+dirFullPath);
	url.openConnection().setUseCaches(false);
	theHTML = new BufferedReader(new InputStreamReader(url.openStream()));
      }catch (MalformedURLException ev)
	{
          System.out.println("URL error in actionPerformed (run) " + ev);
	} 
      catch (IOException ev) 
	{
          System.out.println("IOException in actionPerformed (run)"+ev); 
        }
      try{
	s = theHTML.readLine();
	TreeNodeInfo firstNodeInfo = new TreeNodeInfo(s);
	firstNodeInfo.permission = "drwxr-xr-x";
	top = new DefaultMutableTreeNode(firstNodeInfo);
	System.out.println("rootDir "+s);
        			
        s = theHTML.readLine();               // read string "total xxxx" 

	while((s = theHTML.readLine()) != null) { 
            System.out.println("file "+s);
	    TreeNodeInfo tn = new TreeNodeInfo(s);
            if (!((tn.filename.equals("."))||(tn.filename.equals(".."))))
	      {
		System.out.println("adding to TREE");
		
		top.add(one = new DefaultMutableTreeNode(tn));
		//if this is directory, add dummy content file inside
		if (tn.permission.indexOf('d') == 0){
		  String n = "drwxr-xr-x 3 globus g_globus  3072 Apr 12 09:59 ../";
		  TreeNodeInfo tn_new = new TreeNodeInfo(n);
		  one.add(new DefaultMutableTreeNode(tn_new));
		}
	     }
	}
	
      }catch (IOException ev) 
	{
          System.out.println("IOException in readLine()"+ev); 
        }

       System.out.println("end of performe ");
       return top;
       
    }
  
  

 public static DefaultMutableTreeNode   consTControl(String dirFullPath, 
						     ClientSocket socket)  
    {
      String s;
      DefaultMutableTreeNode top=null,one=null;
      ClientSocket socket;
      
      System.out.println("Filter :/tmp");
      try{

	socket.send(dirFullPath);
	String pwd = socket.receive();

	TreeNodeInfo firstNodeInfo = new TreeNodeInfo(pwd);
	firstNodeInfo.permission = "drwxr-xr-x";
	top = new DefaultMutableTreeNode(firstNodeInfo);
	System.out.println("rootDir "+pwd);
        
	String str_nfiles = socket.receive();
	int    nfiles     = Integer.parseInt(str_nfiles);
	System.out.println("nfiles  "+nfiles);
	
	socket.receive(); // read string "total xxxx" 
	
	for(int i=1;i<nfiles;i++)
	  {
	    s = socket.receive();
	    System.out.println("file "+s);
	    TreeNodeInfo tn = new TreeNodeInfo(s);
            if (!((tn.filename.equals("."))||(tn.filename.equals(".."))))
	      {
		System.out.println("adding to TREE");
		
		top.add(one = new DefaultMutableTreeNode(tn));
		//if this is directory, add dummy content file inside
		if (tn.permission.indexOf('d') == 0){
		  String n = "drwxr-xr-x 3 globus g_globus  3072 Apr 12 09:59 ../";
		  TreeNodeInfo tn_new = new TreeNodeInfo(n);
		  one.add(new DefaultMutableTreeNode(tn_new));
		}
	      }
	  }
      }catch (IOException ev) 
	{
          System.out.println("IOException in readLine()"+ev); 
        }

       System.out.println("end of performe ");
       return top;
       
    }
  
  //Is directory containing only dummy file 
public boolean isDirDummy( DefaultMutableTreeNode lastComponent)
  {
     Object o = lastComponent.getUserObject();
     TreeNodeInfo parentInfo = (TreeNodeInfo)o;

     TreeNode removedOne = lastComponent.getChildAt(0); 
     o = ((DefaultMutableTreeNode)removedOne).getUserObject();
     TreeNodeInfo childInfo = (TreeNodeInfo)o;
     System.out.println("child="+childInfo.filename+"="+
		      "permission="+parentInfo.permission+"="+
		       "cnt="+lastComponent.getChildCount());
     

     if ((parentInfo.permission.indexOf('d') == 0)&&
         (lastComponent.getChildCount() == 1)&&
	 (childInfo.filename.equals("../"))){
       System.out.println("it is Dummy Node");
       return true;
     }
     
     else{
       System.out.println("it is NOT Dummy Node");
       return false;
     }
     
  }

public int  updateTree(String dirFullPath,DefaultMutableTreeNode top)  
    {
      int childCnt=0;
      
      BufferedReader theHTML = null;
      URL url = null;
      String s;
      DefaultMutableTreeNode one=null;
      String host = "osprey3.npac.syr.edu";
      int   port = 1242;

      System.out.println("Filter :/tmp");
      try{
	url = new URL("http",host,port,
		       "/cgi-bin/readAllFiles.pl?"+dirFullPath);
	url.openConnection().setUseCaches(false);
	theHTML = new BufferedReader(new InputStreamReader(url.openStream()));
      }catch (MalformedURLException ev)
	{
          System.out.println("URL error in actionPerformed (run) " + ev);
	} 
      catch (IOException ev) 
	{
          System.out.println("IOException in actionPerformed (run)"+ev); 
        }
      try{
	s = theHTML.readLine();
	//top = new DefaultMutableTreeNode(new TreeNodeInfo(s));
	System.out.println("rootDir "+s);
        			
        s = theHTML.readLine();               // read string "total xxxx" 

	while((s = theHTML.readLine()) != null) { 
            System.out.println("file "+s);
	    TreeNodeInfo tn = new TreeNodeInfo(s);
            if (!((tn.filename.equals("."))||(tn.filename.equals(".."))))
	      {
		System.out.println("adding to TREE");
		childCnt++;
		
		top.add(one = new DefaultMutableTreeNode(tn));
		//if this is directory, add dummy content file inside
		if (tn.permission.indexOf('d') == 0){
		  String n = "drwxr-xr-x 3 globus g_globus  3072 Apr 12 09:59 ../";
		  TreeNodeInfo tn_new = new TreeNodeInfo(n);
		  one.add(new DefaultMutableTreeNode(tn_new));
		}
	     }
	}
	
      }catch (IOException ev) 
	{
          System.out.println("IOException in readLine()"+ev); 
        }

       System.out.println("end of performe ");
       //return top;
       if (childCnt == 0){
	 String n = "drwxr-xr-x 3 globus g_globus  3072 Apr 12 09:59 ../";
	 TreeNodeInfo tn_new = new TreeNodeInfo(n);
	 top.add(new DefaultMutableTreeNode(tn_new));
	 childCnt++;
	 
       }
       return childCnt;
       
    }

public void getSelectedDirContent(TreePath selPath)
  {
    DefaultMutableTreeNode lastComponent = (DefaultMutableTreeNode)
                                           selPath.getLastPathComponent();

    Object o = lastComponent.getUserObject();
    TreeNodeInfo tinfo = (TreeNodeInfo)o;
    TreeNode removedOne = lastComponent.getChildAt(0); 

    if (isDirDummy(lastComponent))
      {
	//Construct subtree
	String selectedDir = getSelectedItem(selPath);
	
	lastComponent.removeAllChildren();
	int childCnt = updateTree(selectedDir,lastComponent);
	
	//announce dummy child is removed
	int[] childIndices = new int[1];
	childIndices[0] = 0;
	TreeNode[] removedChildren = new TreeNode[1];
	removedChildren[0] = removedOne;
	nodesWereRemoved((TreeNode)lastComponent,childIndices,
			  removedChildren);

	//announce some children added to current node	
        childIndices = new int[childCnt];
	for(int i=0;i<childCnt;i++) childIndices[i] = i;
        nodesWereInserted((TreeNode)lastComponent,childIndices);

      }
  }
  
public String getSelectedItem(TreePath selPath)
  {
    int pcount = selPath.getPathCount();
    Object pathComponent =  selPath.getPathComponent(pcount-1);
    
   
    String fullPath="";
    for(int i=0;i<pcount;i++){
      TreeNode tn = (TreeNode)(selPath.getPathComponent(i));
      Object o = ((DefaultMutableTreeNode)tn).getUserObject();
      TreeNodeInfo tinfo = (TreeNodeInfo)o;

      String append = "";
      if ((tinfo.permission.indexOf('d') == 0)||((pcount>1)&&(i==0)))
	append = "/";
      fullPath += tinfo.toString()+append;
    }
    
    return fullPath;
  }

public void treeExpanded(TreeExpansionEvent event)
  {
    System.out.println("treeExpanded is Called !!");
  
    TreePath selPath = event.getPath();
    String newDirName = getSelectedItem(selPath);
    if (newDirName.lastIndexOf("/") == newDirName.length() -1){
	getSelectedDirContent(selPath);
	System.out.println("Getting Ne directory contents: "+newDirName);
    }
        
  }

public void treeCollapsed(TreeExpansionEvent event)
  {
    System.out.println("treeCollapsed is Called !!");
  }


}



class TreeNodeInfo 
{
  String permission,ndirs,user,group,filesize,month,day,time,filename;
  int    nitems;
  
  public TreeNodeInfo (String fileInfo)
  {
    String tokens[] = new String[16];
    int i = 0;
    StringTokenizer st = new StringTokenizer(fileInfo," ",false);
    while(st.hasMoreTokens()){
      tokens[i] = st.nextToken();
      //System.out.println("next token "+tokens[i]);
      i++;
      
    }
    permission = tokens[0];
    ndirs      = tokens[1];
    user       = tokens[2];
    group      = tokens[3];
    filesize   = tokens[4];
    month      = tokens[5];
    day        = tokens[6];
    time       = tokens[7]; 
    filename   = tokens[8];
    for(int j=9;j<i;j++)
      filename += " "+tokens[j];
    
    if (i == 1) // directory name
      filename   = permission;
    nitems = i;
    
  }
  
  public String toString()
  {
    return filename;
  }
   
}
