package webflow.modules.QuantumSimulations;

import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;

public class FileName extends Template {
  
  OutputPort outport;
  String s;
  String disp;
  boolean flag,done;
  WFFileDescriptor outFile = new WFFileDescriptor(); 

  public MetaModule initialize() {
    
    System.err.println("Initialize FileName");
    CreateServerSocket();
    MetaModule mm = new MetaModule("mm");
    outport = new OutputPort("WFFileDescriptor");
    mm.putPortID(outport.getPortID());
    return(mm);
    }
  
  public synchronized void run() {
    
    outFile.setFileAttribute("default");
    done=false;
    flag=false;
    while(true) {
      try {
             wait(1000);
      } catch (InterruptedException e){;}
      
             if(done) {break;}
	     if(flag) {

               if(outport.isConnected()) {
               outport.send(outFile); 
               System.err.println("FileName: send "+outFile.getFileName());
               System.err.println("FileType: send "+outFile.getFileAttribute());
	       }
               else {
               System.err.println("Output Port is not connected!");
	       }   
               flag=false;
	     }
    }

  }
  
    
    public void destroy() {

    outport.destroyPort();
    socket.stop();
    }
    
    public void stop() {}

   
    public void update_value(String s) {

    System.err.println("FileName: "+s);

         if(s.startsWith("DISP")) {
            disp=s.substring(4);
	 }
         if(s.startsWith("FDIR")) {
            outFile.setFileDirectory(s.substring(4));
	 }
         if(s.startsWith("ATTR")) {
            outFile.setFileAttribute(s.substring(4));
	 }
         if(s.startsWith("FILE")) {
	   if(s.equals("FILEShutUp")) {
	    done=true;
           }
	   else {
            outFile.setFileName(s.substring(4));
            flag=true;
	   }
	 }
         if(s.startsWith("HOST")) {
            outFile.setFileHost(s.substring(4));
	 }
    }

}	
    
    
    
