 package webflow.modules.Test;
    
 import webflow.backend.*;
 import java.net.*;
 import java.io.*;
 
 public class readFile implements Module {
 
   InputPort inport;
   OutputPort outport;
   String message;
    
   public MetaModule initialize() {
     MetaModule mm = new MetaModule("mm");
     outport = new OutputPort("String");
     mm.putPortID(outport.getPortID());
     inport = new InputPort("String");
     mm.putPortID(inport.getPortID());
     return(mm);
     }
 
   public void run() {
 
     System.out.println("Proc is running");
     String fileName = "/sunhpc/globus/apache/htdocs/0.0.5/webflow/modules/fileTransfer/Proc.java";
     while(true) {
       //readFile Name
       //String fileName = (String)inport.receive();
       
       File file = new File(fileName);

       //if given file does not exist, loop back
       if ((!(file.exists()))||(!(file.canRead())))
	 continue;
     
       String fileContent = readFileContent(file);
       System.out.println("File content :"+fileContent);
       outport.send(fileContent);
       break;    
     }
   }
      
   public void destroy() {
     outport.destroyPort();
     inport.destroyPort();
   }
   public void stop() {}


   String readFileContent(File file)
   {
     char[] data = null;
     try{
       FileReader in = new  FileReader(file);
       //read file char by char
       int size = (int)file.length();
       data = new char[size];
       int chars_read = 0;
       while(chars_read < size)
	 chars_read += in.read(data,chars_read,size-chars_read);
     }catch(IOException e){
       System.out.println("There is IOException during reading file:"+e);
     }
      
      return new String(data);
   }
   
 }
