 package webflow.modules.Test;
 import webflow.modules.Templates.*;
   
 import webflow.backend.*;
 import java.net.*;
 import java.io.*;
 
 public class writeFile  extends Template{
 
   InputPort inport;
   OutputPort outport;
   String fileName=null;
   boolean flag=false;
       
   public MetaModule initialize() {
     CreateServerSocket();
     MetaModule mm = new MetaModule("mm");
     inport = new InputPort("String");
     mm.putPortID(inport.getPortID());
     return(mm);
     }
 
   public synchronized void run() {
 
     FileOutputStream file=null;
     while(true) {
       try {
	 wait(1000);
       } catch (InterruptedException e){
	 System.err.println("Interrupt during waiting "+e);
       }
    
       System.err.println("Proc is running");
       //readFile Name
       if (flag){   
	 System.err.println("File with flag=true "+fileName);
	 try{
	    file = new FileOutputStream(fileName);
	 }catch(IOException e){
	   System.err.println("File write error: "+e);
	 }
	 	 
	 //if given file does not exist, loop back
	 if (file == null){
	   System.err.println("File write error:"+fileName);
	   flag = false;
	   continue;
	 }
     
	 String fileContent = (String)inport.receive();
	 writeFileContent(file,fileContent);
	 System.err.println("File content writen :"+fileContent
			    +" toFile "+fileName);
	 flag = false;
       }
     }
       
   }
      
public void destroy() {
     outport.destroyPort();
     inport.destroyPort();
   }
   public void stop() {}

   public void update_value(String s)
    {
 
      System.err.println("update_value is CALLED with "+s);
 
      if(s.equals("_make_connection")) {
       System.err.println("CONTROLS1 CONNECTED !!!");
      }
      else if (s.startsWith("FILENAME")){
	System.err.println("I received FILENAME:"+s);
	//received directory name for file browser
	fileName = s.substring("FILENAME".length());
	flag = true;
      }
     
    }


   public void  writeFileContent(FileOutputStream file,String fileContent)
   {
     try{
       DataOutputStream out = new DataOutputStream(file);
       //write fileContent to file at once
       out.writeBytes(fileContent);
     }catch(IOException e){
       System.err.println("There is IOException during reading file:"+e);
     }
      
   }
   
 }
