package webflow.modules.demo.image;

import java.io.*;
import java.net.*;
import java.lang.*;

public class FilterSocket implements Runnable{
Socket socket;

private Thread runner;
HSVfilter filt;
HSBParam param;
boolean bool;
DataOutputStream dos;
DataInputStream dis;
int H,S,V;
  public FilterSocket(String Host,int port, HSBParam f1){
param=f1;
try{
socket=new Socket(Host,port);
dos=new DataOutputStream(socket.getOutputStream());
dis= new DataInputStream(socket.getInputStream());
}catch(IOException e){System.out.println(e);}
filt=null;
start();
  }

  public FilterSocket(Socket aSocket,HSVfilter filter){
 filt=filter;
socket=aSocket;

start();
  }

  public void start(){
    if(runner==null){
runner= new Thread(this);
runner.start();
    }
  }

  public void run(){
     if(filt!=null){
System.out.println("Getting Stream");
        try{
dis=new DataInputStream(socket.getInputStream());
 }catch(IOException e){System.out.println(e);}
System.out.println("going Into Loop");
      while(true){
System.out.println("In loop");
	try{
System.out.println("READING VALUES");
H=dis.readInt();
S=dis.readInt();
V=dis.readInt();
System.out.println("READ VALUES");
filt.setval(H,S,V);
}catch(IOException e){System.out.println(e);}
         }	
      // }catch(IOException e){System.out.println(e);}
       }
     else{
       try{
int flag=dis.readInt();
       }catch(IOException e){System.out.println(e);}
param.dispose();
     }
  }

  public void send(int hue,int sat,int v){
    try{
System.out.println("WRITING VALUES");
dos.writeInt(hue);
dos.writeInt(sat);
dos.writeInt(v);
    }catch(IOException e){System.out.println(e);}
  }

  
    
  public void stop(){
    if(runner!=null){
runner.stop();
runner=null;
try{
socket.close();
}catch(IOException e) {System.out.println(e);}
    }
  }
}
