/*******************************************************************************************
* Class FilterSockettm is a thread  which communicates between the the plotfiltertm module *
* and the plotframetm frame by opening a socket connection betweeen the two	 	   *
*******************************************************************************************/
package webflow.modules.demo.image;

import java.io.*;
import java.net.*;
import java.lang.*;

public class FilterSockettm implements Runnable{
Socket socket;

private Thread runner;
plotfiltertm filt;
plotframetm pframe;
boolean bool;
DataOutputStream dos;
DataInputStream dis;
int Pt;

//constructor
public FilterSockettm(String Host,int port,plotframetm pf ){
pframe=pf;
try{
   socket=new Socket(Host,port);
   dos=new DataOutputStream(socket.getOutputStream());
   dis= new DataInputStream(socket.getInputStream());
   }
catch(IOException e)
{
 System.out.println(e);
}
filt=null;
start();
 }

//constructor
public FilterSockettm(Socket aSocket,plotfiltertm filter)
{
 filt=filter;
 socket=aSocket;
 start();
}



public void start()
{
    if(runner==null)
{
   runner= new Thread(this);
   runner.start();
}
}

  public void run(){
     if(filt!=null){

        try{
dis=new DataInputStream(socket.getInputStream());
 }catch(IOException e){System.out.println(e);}

      while(true){

	try{

Pt=dis.readInt();

filt.setval(Pt);
}
catch(IOException e)
{System.out.println(e);
}
}	
       }
     else{
       try{
int flag=dis.readInt();
       }catch(IOException e){System.out.println(e);}
pframe.dispose();
     }
  }



//writes the value of the scrollbar to the output stream
  public void send(int point){
    try{

dos.writeInt(point);
    }catch(IOException e)
{
 System.out.println(e);
}
}

  
    
  public void stop(){
    if(runner!=null){
runner.stop();
runner=null;
try{
socket.close();
}catch(IOException e) {System.out.println(e);}
    }
  }
}




























