package webflow.modules.demo.image;

import webflow.frontend.*;
import webflow.backend.*;
import gjt.filter.*;
import java.awt.image.*;
import gjt.*;
import java.awt.*;
import java.net.*;
import java.io.*;

public class HSVfilter  implements Module{
	
	Image image;
	ImgData imgdat;
//	ImgPort imgport,imgport1;
	InputPort inport;
    OutputPort outport;
	ServerSocket listener;
ServerSocket sender;
	Socket aSocket;
int w,h;
int[] pixels;
	String hostName;
 	int portNumber;
DataOutputStream dos;
int portNumber1;
 	HSVeditFilter emb1;
boolean bool=false;
int H,S,V;
	FilterSocket socket;
String JeevPortNum=new String("9001/filters"); 
	public MetaModule initialize(){
		imgdat=null;
		MetaModule mm  = new MetaModule("mm");
		emb1 = new HSVeditFilter(0,0,0,0);
/*
		imgport1= new ImgPort();
		mm.putPortID(imgport1.getPortID());
		imgport=new ImgPort();
		mm.putPortID(imgport.getPortID());
*/
		outport = new OutputPort("ImgData");
        mm.putPortID(outport.getPortID());
        inport = new InputPort("ImgData");
        mm.putPortID(inport.getPortID());
 try{
      InetAddress local = java.net.InetAddress.getLocalHost();
      hostName = local.getHostName();
      // open new server socket
      listener = new ServerSocket(0);
      //sender= new ServerSocket(0)
      portNumber = listener.getLocalPort(); 
      //portNumber1=sender.getLocalPort();
    }catch(UnknownHostException e){System.out.println(e);}
    catch(IOException e){System.out.println(e);}
// Html Code to Display Applet 

    String htmlString=new String(" CODE = \"webflow.modules.demo.image.HSVApplet.class\"  WIDTH=600 HEIGHT=1000>\n<PARAM Name=Host");
    htmlString+=" VALUE=";
    htmlString+=hostName;
    htmlString+=">\n<PARAM NAME = portnum VALUE = ";
    htmlString+=String.valueOf(portNumber);
    htmlString+=">\n<PARAM Name=FName VALUE=HSVParam ";
htmlString+=">\n </APPLET>\n</P>\n";
    System.out.println(htmlString);
    mm.setHTML(htmlString);
		return(mm);
		
	}


	public void run(){
	  try{
System.out.println("accepting socket");
              aSocket=listener.accept();
System.out.println("getting socket");
              socket=new FilterSocket(aSocket,this);
	       dos= new DataOutputStream(aSocket.getOutputStream()); 
	  } catch(IOException e) {System.out.println(e);}
		System.out.println("Received Data");
//		imgdat=(ImgData)imgport.receive();
		imgdat = (ImgData) inport.receive();
		 	transform();
		}

	public  void trans(int[] pixels)  	{
		int w = imgdat.width;
		int h = imgdat.height;
		int[] pixelsi = pixels;
System.out.println("Bool ="+ bool);
while(bool){};
bool=true;
       		pixels=emb1.filter(pixels,w,h);
bool=false;
		for(int i=0;i<(w*h);i++)
		for( i=0;i<(w*h);i++)
		{
			imgdat.pixels[4*i]=(byte) ((pixels[i]>>24)& 0xff);
	imgdat.pixels[(4*i)+1]=(byte) ((pixels[i]>>16) & 0xff);
	imgdat.pixels[(4*i)+2]=(byte) ((pixels[i]>>8) & 0xff);
	imgdat.pixels[(4*i)+3]=(byte) (pixels[i] & 0xff);
			
		}	
			
//		imgport1.send(imgdat);
		outport.send(imgdat);
	}
	

	public void destroy(){
confirm(0);
socket.stop();
try{
aSocket.close();
}catch(IOException e) {System.out.println(e);}
//		imgport.destroyPort();
//                imgport1.destroyPort();
	inport.destroyPort();
    outport.destroyPort();


//sender.close();
	}

  void transform(){
if(imgdat!=null){		
			w = imgdat.width;
			 h = imgdat.height;
			 pixels = new int[w*h];
		
			for(int i=0;i<(w*h);i++)
				{
int a=(int)(imgdat.pixels[4*i]);
int r= (int)(imgdat.pixels[(4*i)+1]);
int g= (int)(imgdat.pixels[(4*i)+2]);
int b= (int)(imgdat.pixels[(4*i)+3]);
pixels[i]=(((a<<24)&0xff000000 )|((r<<16)&0x00ff0000 )|((g<<8)&0x0000ff00 )|(b &0x000000ff ));
				} 
				
			System.out.println(pixels[5]);
			trans(pixels);
}	

  }
	
 void confirm(int flag){
    try{

    dos.writeInt(flag);
    }catch(IOException e){System.out.println(e);}
 }	
	

public void stop(){}

  public void setval(int r,int g,int b){
System.out.println("will be Applying CHANGED VALUES");
    while(bool){
    }
System.out.println("Applying CHANGED VALUES");
emb1=new HSVeditFilter(0,r,g,b);
transform();

 }
	public static void main(String[] args){
		Filter emb = new Filter();
			emb.initialize();
			emb.destroy();
		}	               
	

}	
	

