/***************************************************************************************
*  Class plotdatasp generates the 1-D data i.e the cosine wave and sends this data to   *
*  the plotfiltersp module							      *
****************************************************************************************/

package webflow.modules.demo.image;

import webflow.frontend.*;
import webflow.backend.*;
import gjt.filter.*;
import java.awt.image.*;
import gjt.*;
import java.awt.*;
import java.net.*;
import java.io.*;
import java.lang.*;


public class plotdatasp implements Module
{
	ServerSocket listener;
        ServerSocket sender;
	double pixel_value;
	DataInputStream dis;
	double temp1;
	IntData val;
Math m;
double[] Ypixels=new double[360];
double[] Xpixels=new double[360];
String hostName;
int portNumber;
DataOutputStream dos;
boolean bool=false;
PlotPort p1;
int Pt;
float t=0;
double temp;


//initialize method of the module
public MetaModule initialize(){
MetaModule mm  = new MetaModule("mm");
 p1= new PlotPort();
mm.putPortID(p1.getPortID());
return(mm);
}


//run method which calls the the plot method to generate the data and then calls the send method
// to send the data
	public void run(){
	try
       {
           Socket aSocket = p1.getSocket();	
           dis = new DataInputStream(aSocket.getInputStream());
		for(int k=0;k<1000;k++)
		{
                plot(t);   
		p1.send21(200,Xpixels,Ypixels);
		confirm(0);
		t++;
				}
 	}
	catch(IOException e)
	{}
		}


//generates the cosine wave
 public void plot(float t)
{
 int j=0,k=0;
 double y,x=0;
 double w=Math.PI/10f;
 while(j<200)
 {
  y=m.cos(x+w*t);
  temp=y;
  Ypixels[j]=temp;	
  Xpixels[j]=x;
  x=j*Math.PI/200;
  j++;

}

}
	




//destroy method of the module
public void destroy(){

if(p1!=null) p1.destroyPort();
	}

 
// confirms that the filter module has received the data  by reading an integer	
 void confirm(int flag){
    int readflag ;
  try{
  do
      { 
        readflag = dis.readInt();


      } while(readflag!=flag);
 }
catch(IOException e){
System.out.println(e);
}
 }	
	

public void stop(){}               

}	
	





