/**********************************************************************************************
* Class plotfiltertm filters 1-D data and sends the data to the Scivis 1-D module            *
**********************************************************************************************/
package webflow.modules.demo.image;

import webflow.frontend.*;
import webflow.backend.*;
import webflow.modules.demo.SciVis.*;
import gjt.filter.*;
import java.awt.image.*;
import gjt.*;
import java.awt.*;
import java.net.*;
import java.io.*;

public class plotfiltertm implements Module{
	Double data_xvalue,data_yvalue;
        Graphics g;
	IntData pdata,pdata1;
        int imgdat1,imgdat;
	PlotPort p1,p3;
	ServerSocket listener;
        ServerSocket sender;
	Socket aSocket;
	String hostName;
 	int portNumber;
	double temp2,temp3;
	
double[] arr=new double[360];
double[] xarr1=new double[360];
double[] yarr1=new double[360];
double[] xarray;
double[] yarray;

DataOutputStream dos;
DataInputStream dis;
int portNumber1;
boolean bool=false;
int Point,pi=1,inc=0,counter=0;
FilterSockettm socket;
SciVisPlotPort p2;


//initilialize method of the module which creates the ports
public MetaModule initialize(){
MetaModule mm  = new MetaModule("mm");
p2=new SciVisPlotPort();
mm.putPortID(p2.getPortID());
p1= new PlotPort();
mm.putPortID(p1.getPortID());



 try{
      InetAddress local = java.net.InetAddress.getLocalHost();
      hostName = local.getHostName();
      // open new server socket

      listener = new ServerSocket(0);
      portNumber = listener.getLocalPort(); 
    }
   catch(UnknownHostException e)
    {
       System.out.println(e);
    }
    catch(IOException e)
    {
     System.out.println(e);
     }
// Html Code to Display Applet 

    String htmlString=new String(" CODE = \"webflow.modules.demo.image.PlotApplettm.class\"  WIDTH=250 HEIGHT=300>\n<PARAM Name=Host");
    htmlString+=" VALUE=";
    htmlString+=hostName;

    htmlString+=">\n<PARAM NAME = portnum VALUE = ";
    htmlString+=String.valueOf(portNumber);
    htmlString+=">\n<PARAM Name=FName VALUE=plotdata ";
    htmlString+=">\n </APPLET>\n</P>\n";
    System.out.println(htmlString);
    mm.setHTML(htmlString);

		return(mm);
		
	}

//stores the values read from the scrollbar into a variable pi
public void setval(int pt)
{

	pi=pt;

}

//run method of the module
	public void run(){
	  try{
	        aSocket=listener.accept();
	        socket=new FilterSockettm(aSocket,this);
	dos= new DataOutputStream(aSocket.getOutputStream()); 
	Socket bSocket = p2.getSocket();
        dis = new DataInputStream(bSocket.getInputStream());
	  } 
	catch(IOException e) 
		{
			System.out.println(e);
		}
		for(int k=0;k<1000;k++)
		
		{
		pdata=(IntData)p1.receive2();  //receives the data from the plotdatatm module
		int len=pdata.len;
		xarray=new double[len];
		yarray=new double[len];
		for(int j=0;j<len;j++)
		{
		 xarray[j]=pdata.xvalue[j];
		 yarray[j]=pdata.yvalue[j];
		}	
		
		transform(counter,len); 
		counter++;
		}
	}
	

//filters the data dependending on the value pi received from the scrollbar and the value
//of counter	
public void transform(int counter,int len)
{		
		
		while(bool){}
		bool=true;
		
				
		
		if(counter%pi==0)
		{
		 
		  p2.send_1d(len,xarray,yarray);
		 }
		
	
		if(counter%pi==0)confirm(0);
		bool=false;
		
		       

}


//destroy method of the module
public void destroy(){
confirm1(1);
socket.stop();
try{
aSocket.close();
}
catch(IOException e) 
{System.out.println(e);
}
		p1.destroyPort();
       		p2.destroyPort();
		
	}

 

//confirm method waits until the data is received by the scivis module	
 void confirm(int flag){
    int readflag ;
  try{
  do
      { 
        readflag = dis.readInt();


      } while(readflag!=flag);
 }
catch(IOException e){
System.out.println(e);
}
}


//confirm1 writes a 1 to the socket to inform the applet to destroy itself
void confirm1(int flag1)
{
 try{

    dos.writeInt(flag1);
    }catch(IOException e){System.out.println("exception"+e);}
 }	
	

public void stop(){}               

}	
	












