/************************************************************************************
* Class plotframesp is the frame which is embedded in the PlotAppletsp applet.It *
* opens a socket connection with FilterSocketsp, which communicates between the    *
* PlotAppletsp and the plotfiltersp module					    	   *
************************************************************************************/
  
package webflow.modules.demo.image;

import java.awt.*;
import java.applet.*;


public class plotframesp extends Frame implements Runnable
{
 int port;
 int point,num=1;;
 String host;
 FilterSocketsp socket;
 private Thread runner;
 TextArea text1,text2;
 Font fo;
 Button b1,b2,b3;
 Scrollbar horizontalScrollbar;
 public plotframesp(String host,int port,String name)
 {
 super(name);
 socket=new FilterSocketsp(host,port,this);
 setLayout(new GridLayout(4,1));
 resize(426,266);
 horizontalScrollbar = new java.awt.Scrollbar(Scrollbar.HORIZONTAL,0,1,1,100);
 horizontalScrollbar.reshape(115,36,250,21);

 text2=new java.awt.TextArea("MODULE FOR SPATIAL FILTERING");	
 text1=new java.awt.TextArea("VALUE FROM THE SCROLLBAR::");
   text1.appendText(String.valueOf(num));
 add(text2);
 add(horizontalScrollbar);
 add(text1); 
 
   show();
 start();
}

//sets the value of the scrollbar in the textfield
void set_text(String tex)
{
 text1.replaceText(tex,25,27);
}


public boolean handleEvent(Event event) {
if(event.target==horizontalScrollbar)
     scroll_event(event);
return true;
}

void scroll_event(Event event)
{
 switch(event.id)
 {
  case Event.SCROLL_ABSOLUTE:
  case Event.SCROLL_LINE_DOWN:
  case Event.SCROLL_LINE_UP:
  case Event.SCROLL_PAGE_DOWN:
  case Event.SCROLL_PAGE_UP:
  point=((Integer)event.arg).intValue();
   String tex=String.valueOf(point);
  set_text(tex);
  write_val();
 }
}


//sends the value of the scrollbar to the DataOutputStream 
void write_val()
{

 socket.send(point);
}             

public void start(){
    if(runner==null){
runner=new Thread(this);
runner.start();
    }
  }

  public void stop(){
    if(runner!=null){
runner.stop();
runner=null;
    }
socket.stop();
  }


 public void run()
{
   	java.awt.Scrollbar horizontalScrollbar;
}

}







