package webflow.util;

/**
 * The Action interface is implemented by classes that can be run 
 * asynchronously by worker threads
 *
 * @version 0.1.0 first draft
 */
public interface Action {
  /** 
   * Services the Action. This method will be invoked by the serving
   * thread. 
   */
  public void service();
}
