
package webflow.util.EventDispatcher;

import java.util.EventListener;

/**
 * The listener interface for receiving WebFlowEvents. All classes that
 * want to register themselves as listeners for WebFlowEvents have to 
 * implement this interface
 * 
 * @version 0.1.0 first draft
 */
public interface WFEventListener extends EventListener {
  /**
   * Gets invoked whenever the event occured at an object with whom the
   * WebFlowEventListener is a registered listener. 
   */
  public void eventOccurred(webflow.util.EventDispatcher.WFEvent e);
}
