
package webflow.util;

import java.lang.Exception;

/*
* When you try to add a ListItem object which is
* different from the already added objects then
* you will get this exception. A List has to have
* only one kind of ListItem objects. This class
* is decided when you add the first element.
*/
public class 
NotAllowableListItemException extends Exception
{

  public 
  NotAllowableListItemException()
  { super("ListItem object is not correct "); }

}// end of class NotAllowableListItemException
