package webflow.backend;

import java.io.*;

public class ImgData implements Serializable{
	public int width;
	public int height;
	public byte[] pixels;
	//transient Image image;
	
	public  ImgData(){
		width=0;	
		height = 0;
		pixels = new byte[width*height*4];
		}
	
	public ImgData(int width , int height){
		this.width = width;
		this.height= height;
		pixels = new byte[width*height*4];
		}
	
	public ImgData(byte[] pixels,int width,int height){
		this.width=width;
		this.height=height;
		this.pixels=new byte[width*height*4];
		this.pixels=pixels;
		}
	
	public void setpixels(byte[] pixels,int width,int height){
		this.width=width;
		this.height=height;
		this.pixels=pixels;
	}
	private void readObject(java.io.ObjectInputStream s) 
		throws ClassNotFoundException, IOException {
		s.defaultReadObject(); 
		this.width=s.readInt();
		this.height=s.readInt();
		this.pixels=new byte[width*height*4];
		this.pixels=(byte[])(s.readObject());
	}
	private void writeObject(ObjectOutputStream s) 
		throws IOException {
		s.defaultWriteObject();
		s.writeInt(width);
		s.writeInt(height);
		s.writeObject(pixels);
	}
} 
