
package webflow.backend;
import java.io.*;
import java.lang.*;
import java.net.*;


public class PlotPort extends Port{
  DataInputStream is;
//  DataInputStream din;
  DataOutputStream os;
  IntData data;
  double d;
  double[] x;
  double[] y;
  double[] z;
  double[] fxyz;
  double[] fx;
  int nx=0;


 void
 convertDoubleToByteArray(double val, byte[] ret)
 {
    long vals = Double.doubleToLongBits(val);
    
    for(int i=0;i<8;i++)
    {
        ret[i] = (byte)(vals & 0x00000000000000ff);
        vals   = vals >> 8;
    }
 } 

 public void 
 send_ser2d(int len, double fxy[][])
 {
   
   System.out.println(" HELLO I am in SENDser2d");

    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        
        DataOutputStream dos = new DataOutputStream(bos);

        dos.writeInt(len);

        for(int i=0;i<len;i++)
        { 
           dos.writeDouble(fxy[i][0]);
	  // System.out.println("xs"+fxy[i][0]);
           dos.writeDouble(fxy[i][1]);
	  // System.out.println("ys"+fxy[i][1]);
           dos.writeDouble(fxy[i][2]);
	  // System.out.println("fs"+fxy[i][2]);
           //System.out.print(i+" + "); 

        }// end of for
  
        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());

    } catch(IOException e){}

   // System.out.println(" I sent "+len+" elements of the data in SEND2()!!!!@@@@@@");

 }// end of send_ser2d()





 public int 
  readFrom(DataInputStream inData) throws IOException
  {
     int retVal = 0;

     int num_ele = inData.readInt();

    /// System.out.println(" I will read  num_ele elements = "+num_ele);

     byte[] data = new byte[num_ele]; 

     inData.readFully(data,0,num_ele);

    // System.out.println(" I will read  rest elements = "+num_ele);

     DataInputStream in = new DataInputStream(new ByteArrayInputStream(data));

     /** Read the number of elements */
     nx = in.readInt();
    // System.out.println(" I will read  nx elements = "+nx);

     /** Define the elements */
     x = new double[nx];
     fx = new double[nx];

     /** Read the elements */
     for(int i=0;i<nx;i++)
     {
         x[i] = in.readDouble();
        fx[i] = in.readDouble();
        //System.out.print(" ( "+x[i]+" , "+fx[i]+" ) ");

     }// end of for

     retVal = 1;
    
     return retVal;

  }// end of readFrom()





public Object receive2()
{
 IntData ret = null;

   

    if(getSocket()!=null) 
    { 

      try
      {
         is =  new DataInputStream(new BufferedInputStream(getSocket().getInputStream()));
                 if(readFrom(is)!=1) 
       {
        ret = null;
	}
	else
	{
	ret=new IntData(nx,x,fx);
	}
                  /** Write Confirmation */
         os=new DataOutputStream(getSocket().getOutputStream());
         os.writeInt(0);
 
      } catch(IOException ioe)
        { System.out.println("a1"); ret=null; }
        
    } else System.out.println( "Socket is EMPTY! receive in SciVisPort2D_ser.java ");

    return ret;

  }// end of receive()





public int 
  readFrom3d(DataInputStream inData) throws IOException
  {
     int retVal = 0;

     int num_ele = inData.readInt();

     //System.out.println(" I will read  num_ele elementstttt = "+num_ele);

     byte[] data = new byte[num_ele]; 

     inData.readFully(data,0,num_ele);

    // System.out.println(" I will read  rest elementstttt = "+num_ele);

     DataInputStream in = new DataInputStream(new ByteArrayInputStream(data));

     /** Read the number of elements */
     nx = in.readInt();
   //  System.out.println(" I will read  nx elementsttttt = "+nx);

     /** Define the elements */
     x = new double[nx];
     y = new double[nx];
     z=new double[nx];
     fxyz = new double[nx];

     /** Read the elements */
     for(int i=0;i<nx;i++)
     {
         x[i] = in.readDouble();
 //	System.out.println("xr"+x[i]);
         y[i] = in.readDouble();
	//System.out.println("yr"+y[i]);
         z[i]=in.readDouble();
//	System.out.println("zr"+z[i]);
        fxyz[i] = in.readDouble();
	//System.out.println("fxr"+fxyz[i]);
       

     }// end of for

     retVal = 1;
   //  System.out.println(" I read all data !!!!! ");

     return retVal;

  }// end of readFrom()



public Object receive3d()
{
    IntData ret=null;   

    if(getSocket()!=null) 
    { 

      try
      {
        // System.out.println("entered recieve3d");
         is =  new DataInputStream(new BufferedInputStream(getSocket().getInputStream()));
        

         if(readFrom3d(is)!=1) { ret = null;}
         else
	{
	 ret=new IntData(nx,x,y,z,fxyz);
	
}
        

         /** Write Confirmation */
         os =  new DataOutputStream(getSocket().getOutputStream());
         os.writeInt(0);
       


      } catch(IOException ioe)
        { System.out.println("a1"); ret=null; }
        
    } else System.out.println( "Socket is EMPTY! receive in SciVisPort2D_ser2d.java ");

    return ret;

   
  }// end of receive()





 public Object receive()
 {
  if(getSocket()!=null)
  {
   try{
   is=new DataInputStream(getSocket().getInputStream());
    int len=is.readInt();
    double xval[];
    double yval[];
    xval = new double[len];
     yval= new double[len];
     for(int i=0;i<len;i++)
     { 
     xval[i]=is.readDouble();
      yval[i]=is.readDouble();
      }
      data=new IntData(len,xval,yval);
       os =  new DataOutputStream(getSocket().getOutputStream());
      os.writeInt(0);
     }
   catch(IOException e)
   {}
   return data;
} else
  {
return null;
}
 }



public void
 send_3d(int len, double fxyz[][])
 {

    System.out.println(" HELLO I am in SEND3DDD(). I will send "+len+" elements !!!!@@@@@@");

    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();

        DataOutputStream dos = new DataOutputStream(bos);

        dos.writeInt(len);
      //  System.out.println("len"+len);
        for(int i=0;i<len;i++)
        {
           dos.writeDouble(fxyz[i][0]);
         //  System.out.println("xs3"+fxyz[i][0]);
           dos.writeDouble(fxyz[i][1]);
	  // System.out.println("ys3"+fxyz[i][1]);
           dos.writeDouble(fxyz[i][2]);
	 // System.out.println("zs3"+fxyz[i][2]);
           dos.writeDouble(fxyz[i][3]);
	 //  System.out.println("fxs3"+fxyz[i][3]);
	  

           //System.out.print(i+" + ");

        }// end of for

        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());
 } catch(IOException e){}

 //   System.out.println(" I sent "+len+" elements of the data in SEND2()!!!!@@@@@@");

 }// end of send_ser2d()





 public void 
 send21(int len, double[] x, double[] y)
 {
   
   
    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        
        DataOutputStream dos = new DataOutputStream(bos);

        dos.writeInt(len);

        for(int i=0;i<len;i++)
        { 
           dos.writeDouble(x[i]);
           dos.writeDouble(y[i]); 
           //System.out.print(i+" + "); 

        }// end of for
  
        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());

    } catch(IOException e){}

  

 }// end of send2()


 public void send(Object data1)
 {
try{
 os=new DataOutputStream(getSocket().getOutputStream());
 data=(IntData)data1; 
 os.writeInt(data.len);
for(int i=0;i<data.len;i++){
 os.writeDouble(data.xvalue[i]);
 os.writeDouble(data.yvalue[i]); 
}
 //System.out.println("xval"+data.xvalue);
 //System.out.println("yval"+data.yvalue);
 }catch(IOException e){}
}

 public void 
 send2(int len, double[] x, double[] y)
 {
   
   // System.out.println(" HELLO I am in SEND2(). I will send "+len+" elements !!!!@@@@@@");

    try
    {
        //os=new DataOutputStream(new BufferedOutputStream(getSocket().getOutputStream()));
        os=new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(len);

        for(int i=0;i<len;i++)
        { 
           os.writeDouble(x[i]);
           os.writeDouble(y[i]); 
           //System.out.print(i+" + "); 

         }// end of for
  //Sdata = prepareCustom(); // Test 
    //Sdata = prepareCustom12(); // Test 

    } catch(IOException e){}

   // System.out.println(" I sent "+len+" elements of the data in SEND2()!!!!@@@@@@");

 }// end of send2()


 public void
 send_bbser2d(double[] bb, int nx, int ny, double fxy[])
 {

    System.out.print(" HELLO I am in send_bbser2d(). I will send nx "+nx);
    System.out.println(" ny "+ny+" elements !!!!@@@@@@");

    try
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();

        DataOutputStream dos = new DataOutputStream(bos);

        dos.writeInt(nx);
        dos.writeInt(ny);

        dos.writeFloat((float)bb[0]);
        dos.writeFloat((float)bb[1]);
        dos.writeFloat((float)bb[2]);
        dos.writeFloat((float)bb[3]);

        for(int i=0;i<nx*ny;i++) dos.writeDouble(fxy[i]);

        os = new DataOutputStream(getSocket().getOutputStream());
        os.writeInt(bos.size());
        os.write(bos.toByteArray(),0,bos.size());

    } catch(IOException e){}

    System.out.println(" I sent "+(nx*ny)+" elements of the data in send_bbser2d()!!!!@@@@@@");

 }// end of send_bbser2d()



  
 
}









