
package webflow.frontend.WFtree;

import uci.graphedit.*;

public class
ActionOpenSubtree extends Action
{
   private TreeNode mynode = null;

   /** */
   public
   ActionOpenSubtree(TreeNode _mynode)
   {  super();
      mynode = _mynode;
   }// end of constructor

   /** 
   * If the node is already Open, then close it.
   * If it is not Open, then Open it.
   */
   public void
   doIt(java.awt.Event evt)
   {  
     if(mynode!=null)
     {  
        if(mynode.isOpen()==true) 
             mynode.unOpen();
        else mynode.open();

     }// end of if
 
   }// end of doIt()

   /** */
   public void
   undoIt() {}

}// end of class ActionOpenSubtree
