package webflow.modules.QuantumSimulations;

import webflow.backend.*;
import java.net.*;
import java.io.*;
import webflow.modules.Templates.*;

public class EditFile extends Template {
  
  InputPort inport;
  OutputPort outport;
  String message,newmessage;
  String command,editor;
  String disp;
  WFFileDescriptor inFile, outFile;
  String FileName;
  
  public MetaModule initialize() {
    
    System.err.println("--------- INITILIZATION OF EDIT FILE ----------");
    System.err.println("--------- INITILIZATION OF EDIT FILE ----------");

    CreateServerSocket();
    MetaModule mm = new MetaModule("mm");

    outport = new OutputPort("WFFileDescriptor");
    System.err.println("got outport");
    ID outputID = outport.getPortID();
    System.err.println("output port ID :"+ outputID.getInt());
    mm.putPortID(outport.getPortID());

    inport = new InputPort("WFFileDescriptor");
    System.err.println("got inport");
    ID inputID = inport.getPortID();
    System.err.println("input port ID :"+ inputID.getInt());
    mm.putPortID(inport.getPortID());

    System.err.println("======= DONE with INIT of EditFile ======");
    System.out.println("======= DONE with INIT of EditFile ======");
    newmessage=null;
    return(mm);
    }
  
  public void run() {
    
    outFile = new WFFileDescriptor();
    //wait till you know the ip address of the display
    
    while(newmessage==null) {;}
    System.out.println("set display to: "+newmessage);
    disp=newmessage.substring(4);
    editor="/usr/npac/bin/emacs";

    while(true)
      {
        inFile = (WFFileDescriptor)inport.receive();
        FileName = inFile.getFileDirectory()+inFile.getFileName(); 
        if(editor.endsWith("emacs")) {
           command = editor+" "+FileName+" -d "+disp+":0";
	}
        else {
           command = editor+" "+FileName;
        }
        System.out.println("EditFile command: "+command);
        try {
              Process p=Runtime.getRuntime().exec(command);
              p.waitFor();
	}
        catch (Exception e) {System.out.println("EditFile Error: "+e.toString());}
        if(outport.isConnected()) {
           outFile.setFileName(inFile.getFileName());
           outFile.setFileDirectory(inFile.getFileDirectory());
           outFile.setFileHost(inFile.getFileHost());
           outFile.setFileAttribute(inFile.getFileAttribute());
       	   outport.send(outFile);
	}
      }
  }
  
    
    public void destroy() {

    outport.destroyPort();
    inport.destroyPort();
    }
    
    public void stop() {}
    
  public void update_value(String s) {
  System.out.println("EditFile: new message: "+s);
  newmessage = s;
  if(newmessage.startsWith("EDIT")) {
     String neweditor = newmessage.substring(4);
     System.out.println("neweditor :"+neweditor);
     if(neweditor.endsWith("vi")) {
       editor = "xterm -d "+disp+":0 -e "+neweditor;
     }
     else {
       editor=neweditor;
     }
     System.out.println(editor);
     }
  }  
   

}	
    
    
    
