package webflow.modules.QuantumSimulations;

import java.net.*;
import java.io.*;

public class WFFileDescriptor extends Object implements Serializable {

private String FileName;
private String FileDirectory;
private String FileHost;
private String FileAttribute;

  public WFFileDescriptor(String Name, String Directory, String Host, String A) {
    FileName = Name;
    FileDirectory = Directory;
    FileHost = Host;
    FileAttribute = A;
  }

  public WFFileDescriptor(String Name, String Directory, String Host) {
    FileName = Name;
    FileDirectory = Directory;
    FileHost = Host;
    FileAttribute = null;
  }

  public WFFileDescriptor(String Name, String Directory) {
    FileName = Name;
    FileDirectory = Directory;
    try {
    InetAddress local = InetAddress.getLocalHost();
    FileHost = local.getHostName();
    } catch(UnknownHostException e) {System.out.println(e);}
    FileAttribute = null;
  }

  public WFFileDescriptor(String Name) {
    FileName = Name;
    FileDirectory = "/tmp/";
    try {
    InetAddress local = InetAddress.getLocalHost();
    FileHost = local.getHostName();
    } catch(UnknownHostException e) {System.out.println(e);}
    FileAttribute = null;
  }

  public WFFileDescriptor() {
    FileName = "dummy";
    FileDirectory = "/tmp/";
    try {
    InetAddress local = InetAddress.getLocalHost();
    FileHost = local.getHostName();
    } catch(UnknownHostException e) {System.out.println(e);}
    FileAttribute = null;
  }

  public String getFileName() {return FileName;}
  public String getFileDirectory() {return FileDirectory;}
  public String getFileHost() {return FileHost;}
  public String getFileAttribute() {return FileAttribute;}

  public void setFileName(String Name) {FileName=Name;}
  public void setFileDirectory(String Name) {FileDirectory=Name;}
  public void setFileHost(String Name) {FileHost=Name;}
  public void setFileAttribute(String Name) {FileAttribute=Name;}

}
