package webflow.modules.Test;
    
import webflow.backend.*;
import java.net.*;
import java.io.*;

public class Proc implements Module {

  InputPort inport;
  OutputPort outport;
  String message;
    
  public MetaModule initialize() {
    MetaModule mm = new MetaModule("mm");
    outport = new OutputPort("String");
    mm.putPortID(outport.getPortID());
    inport = new InputPort("String");
    mm.putPortID(inport.getPortID());
    return(mm);
    }
 
  public void run() {
    int i = 0;

    while(true) {
      System.out.println("Proc is running");
      message = (String)inport.receive();
      outport.send(message+". <-- processed(" + i + ")");
    }
  }
     
  public void destroy() {
    outport.destroyPort();
    inport.destroyPort();
  }
  public void stop() {}
}
