/**********************************************************************************************
* Class plotfilter3dsp filters 3-D to 2-D data and sends the data to the Scivis 2-D module   *     
**********************************************************************************************/
package webflow.modules.demo.image;

import webflow.frontend.*;
import webflow.backend.*;
import webflow.modules.demo.SciVis.*;

import gjt.filter.*;
import java.awt.image.*;
import gjt.*;
import java.awt.*;
import java.net.*;
import java.io.*;

public class plotfilter3dsp implements Module{
	Double data_xvalue,data_yvalue;
        Graphics g;
	IntData pdata,pdata1;
        int imgdat1,imgdat,counter;
	PlotPort p1,p3;
        SciVisPlotPort p2; 

	ServerSocket listener;
        ServerSocket sender;
	Socket aSocket;
	String hostName;
 	int portNumber;

	double temp2,temp3;
	
double[] arr=new double[360];
double[] xarr1;
double[] yarr1;
double[] zarr1;
double[] fxyz1;
double[][] fxy1; 
double[][] fxy2;
double[][] fxy3;
double[] xarray;
double[] yarray;
double[] zarray;
double[] fxyz;
DataOutputStream dos;
DataInputStream dis;
int portNumber1;
boolean bool=false;
int Point,bvalue=1,pi=0,inc=0;
FilterSocket3dsp socket;
 

//initilialize method of the module which creates the ports
public MetaModule initialize(){
MetaModule mm  = new MetaModule("mm");
p2=new SciVisPlotPort();
mm.putPortID(p2.getPortID());
p1= new PlotPort();
mm.putPortID(p1.getPortID());

 try{
      InetAddress local = java.net.InetAddress.getLocalHost();
      hostName = local.getHostName();
      // open new server socket

      listener = new ServerSocket(0);
      portNumber = listener.getLocalPort(); 
    }
   catch(UnknownHostException e)
    {
       System.out.println(e);
    }
    catch(IOException e)
    {
     System.out.println(e);
     }
// Html Code to Display Applet 

    String htmlString=new String(" CODE = \"webflow.modules.demo.image.PlotApplet3dsp.class\"  WIDTH=250 HEIGHT=300>\n<PARAM Name=Host");
    htmlString+=" VALUE=";
    htmlString+=hostName;

    htmlString+=">\n<PARAM NAME = portnum VALUE = ";
    htmlString+=String.valueOf(portNumber);
    htmlString+=">\n<PARAM Name=FName VALUE=plotdata ";
    htmlString+=">\n </APPLET>\n</P>\n";
    System.out.println(htmlString);
    mm.setHTML(htmlString);

		return(mm);
		
	}


//stores the value from the scrollbar into variable pi
public void setval(int pt)
{

pi=pt;

}

//stores the value of the button (1 for XY,2 for YZ,3 for XZ) into variable bvalue
public void setbval(int pt)
{
 
bvalue=pt;

}


//run method of the module
	public void run(){
	  try{
              aSocket=listener.accept();

              socket=new FilterSocket3dsp(aSocket,this);
	       dos= new DataOutputStream(aSocket.getOutputStream()); 
	  Socket bSocket = p2.getSocket();
           dis = new DataInputStream(bSocket.getInputStream());
	  } 
	catch(IOException e) 
		{
			System.out.println(e);
		}
		
	     
		for(int l=0;l<100;l++)
		{
		counter=0;
		transform();
			}
	}
	
//receives the data from the plotfilter3dsp module and filters the data and sends it to the 
//Scivis2d- module	
public void transform()
{		double dummy,a=0.333;
  		 pdata=(IntData)p1.receive3d();			
                int length=pdata.len;
                double sizelen=Math.pow((double)length,a);
		
                double szlen=Math.rint(sizelen);
               
		double val=(szlen*pi)/100;
                int value=(int)val;
              
                xarray=new double[length];
                yarray=new double[length];
                zarray=new double[length];
                fxyz=new double[length];
                xarr1=new double[length];
                yarr1=new double[length];
                zarr1=new double[length];
                fxyz1=new double[length];
		for(int j=0;j<length;j++)
		{
		
		 xarray[j]=pdata.xvalue[j];
		
		 yarray[j]=pdata.yvalue[j];   //receives the data from the plotdata3dsp module
		
                 zarray[j]=pdata.zvalue[j];
		
                 fxyz[j]=pdata.fxyz[j];
		 
		}
		
		while(bool){}
		bool=true;		
		
              
		for(int j=0;j<length;j++)

		{
                  if(bvalue==1)			//if XY button is depressed
		 {
		
                  if(zarray[j]==value)
	         {
		  
		  xarr1[counter]=xarray[j];
		  yarr1[counter]=yarray[j];
                  fxyz1[counter]=fxyz[j];
		 
	       
                  counter++;
        	}         
      		
		 }
                 if(bvalue==2)			//if YZ button is depressed
		 {
                
                  if(xarray[j]==value)
		  {
		  yarr1[counter]=yarray[j];
		  zarr1[counter]=zarray[j];
                  fxyz1[counter]=fxyz[j];
		  counter++;
		 }
		 }
                 if(bvalue==3)			//if XZ button is depressed
		 {
		  if(yarray[j]==value)
		  {
		   xarr1[counter]=xarray[j];
		   zarr1[counter]=zarray[j];
                   fxyz1[counter]=fxyz[j];
		   counter++;
		 }
		}
		
	}		
		bool=false;	
		int k=0;
		int len=counter;
                fxy1=new double[len][3];
		fxy2=new double[len][3];
                fxy3=new double[len][3];
                if(bvalue==1)				
		{				//send the 2D data for the XY plane
		for(int i=0;i<len;i++)
		{
		  fxy1[i][0] = xarr1[i];
                  fxy1[i][1] = yarr1[i];
         	  fxy1[i][2] = fxyz1[i];
                
	        
		}
		
		p2.send_2d("Voyager1",len,fxy1);
		
	        confirm(0);
		
	
		}
		 if(bvalue==2)
		{
               
		for(int i=0;i<len;i++)
		{
		  fxy2[i][0] = yarr1[i];
                  fxy2[i][1] = zarr1[i];
         	  fxy2[i][2] = fxyz1[i];		//send the 2D data for the  YZ plane
                
	         
		}
		
		
		p2.send_2d("Voyager2",len,fxy2);
		
                confirm(0);
		
	      
		}
		 if(bvalue==3)
		{
                for(int i=0;i<len;i++)
		{
		  fxy3[i][0] = xarr1[i];
                  fxy3[i][1] = zarr1[i];
         	  fxy3[i][2] = fxyz1[i];	//send the 2D data for the XZ plane
                 
	         
		}				
	     p2.send_2d("Voyager3",len,fxy3);	
		
                confirm(0);
	
             
		}
		
		
		
	       

}

//destroy method of the module
public void destroy(){
confirm1(1);
socket.stop();
try{
aSocket.close();
}
catch(IOException e) 
{System.out.println(e);
}
		p1.destroyPort();
       		p2.destroyPort();
		
	}

 
// confirm method waits until the data is received by the scivis module	
 void confirm(int flag){
    int readflag ;
  try{
  do
      { 
        readflag = dis.readInt();


      } while(readflag!=flag);
 }
catch(IOException e){
System.out.println(e);
}
}

//confirm1 writes a 1 to the socket to inform the applet to destroy itself
void confirm1(int flag1)
{
 try{

    dos.writeInt(flag1);
    }catch(IOException e){System.out.println("exception"+e);}
 }	
	

public void stop(){}               

}	
	









