package webflow.modules.demo.io;

import java.awt.*;
import webflow.frontend.*;
import webflow.backend.*;
import webflow.modules.demo.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.awt.image.*;

public class 
InputAppletFrame extends Frame 
                 implements Runnable 
{

 String ImgUrl=new String("http://osprey1.npac.syr.edu:9080/frog.gif");    
  ImgData  imgdat;
  Panel panel1;
  Button Start;
  Socket s;
  DataInputStream dis;
  DataOutputStream dos;
  Thread runner=null;	
  String hostName;
  int portNum;
  Show  can;
  //ImageCanvas  can;
  int flags=0;
  boolean flagi=true;
  Image img;
  Frame frame;
  Canvas View;
  Panel panel;
  MediaTracker mt;
  String name;

  public 
  InputAppletFrame(String _host, int PortNumber, 
                   String frameName, Applet pappy)
  {

       hostName = _host;
       portNum = PortNumber;
       name = frameName; 

       try
       {
          s=new Socket(hostName,portNum);
          //System.out.println("Socket created " + hostName +" " + portNum);
          dis=new DataInputStream(s.getInputStream());
          dos= new DataOutputStream(s.getOutputStream());

       } catch(IOException e){System.out.println(e);};

       //mt = new MediaTracker(this); 

       //System.out.println("imgUrl "+ pappy.getCodeBase());
       img = pappy.getImage(pappy.getCodeBase(),"doc/images/frog.gif");

       /*
       mt.addImage(img,0);
       try 
       { 
          mt.waitForID(0); 
       } catch (InterruptedException e){System.out.println(e);} 
 
       //System.out.println(" Image is loaded ");
       */

       can   = new Show();

       can.get(img);

       setTitle(name);
       add("Center",can);
       resize(300,300);
       validate();

       show();
       start();

  }// end of if
  

  public void 
  start()
  {
      if(runner==null)
      {
         runner=new Thread(this);
         runner.start();
      }

  }// end of start()
  
  public void 
  run()
  {
     //System.out.println(" I am in start method ");

     while((flagi)&&(flags==0))
     {
       flags=send() ;
//       System.out.println(" I sended the image ");
     }

     try
     {  s.close();
     } catch(IOException e)
       {  //System.out.println(e);
          //e.printStackTrace();
       }

     dispose();

     //System.out.println(" End of Run() ");

  }// end of run()

  
  public int 
  send()
  {
    ImgData imgdat;
    try
    {
      int flag=dis.readInt();
      if(flag==0)
      {  imgdat=can.GetPixels();
         dos.writeInt(imgdat.width);
	     dos.writeInt(imgdat.height);
       
	     dos.write(imgdat.pixels,0,imgdat.width*imgdat.height*4);	
	     return 0;
      }
    } catch(IOException e)
      {  //System.out.println(e);
         //e.printStackTrace();
      }
    return 1;
  }

    public void 
    stop()
    {
      if(runner!=null)
      {
         runner.stop();
         runner=null;
      }


     try
     {  s.close();
     } catch(IOException e)
       {  //System.out.println(e);
          //e.printStackTrace();
       }

      dispose();

    }// end of stop()

}// end of InputAppletFrame
