package webflow.modules.demo.io;

import java.awt.*;
import webflow.frontend.*; 
import webflow.backend.*;
import webflow.modules.demo.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.awt.image.*;

public class 
OutputAppletFrame extends Frame 
                  implements Runnable
{
  ImgData  imgdat;
  Panel panel1;
  Socket s;
  DataInputStream dis;
  DataOutputStream dos;
  Thread runner=null;	
  String hostName;
  int portNum;
  Frame frame;
  Show  can;
  Image img;
  Panel panel;
  int flag=1;	
  String name;
 
  public 
  OutputAppletFrame(String _host, int PortNumber,
                    String frameName, Applet pappy) 
  {

    hostName = _host;
     portNum = PortNumber;
        name = frameName;

    try
    {
      s=new Socket(hostName,portNum);
      dis=new DataInputStream(s.getInputStream());
      dos= new DataOutputStream(s.getOutputStream());

    } catch(IOException e)
      {  System.out.println(e);
         e.printStackTrace(); 
      }

    can= new Show();
     
    setTitle(name);

    add("Center",can);
    resize(300,300);

   // try{
    //System.out.println("getting image");
    // img =getImage(getCodeBase(),"frog1.gif");
    //  can.get(img);
      // }catch(MalformedURLException e){System.out.println(e);}

    validate();
    show();

    start();

  }// end of init()

     public void 
    start()
    {
      if(runner==null)
      {
         runner=new Thread(this);
         runner.start();
      }

    }// end of start()

    /**
    */
	public void 
    run()
    {
       //System.out.println("I am in start");

       while (flag==1)
       {
         flag=1;
         try
         {
            flag=dis.readInt();

           receive();
           can.get(img);	
           can.repaint();

         } catch(IOException e)
           {  //System.out.println(e);
              /** Intentional */
              //e.printStackTrace();
              flag=0;
           }

       }// end of while
    
       try
       {  s.close();
       } catch(IOException e)
         {  //System.out.println(e); 
            //e.printStackTrace();
         }

       dispose();

       //System.out.println("I am end of Run() ");

    }// end of run()			

		
    /**
    */
	public void  
    receive()
    {

      try
      {
        int w = dis.readInt(); 
        int h = dis.readInt();
        byte[] pixelsb = new byte[h*w*4];

        dis.readFully(pixelsb,0,w*h*4);
        imgdat = new  ImgData(pixelsb,w,h);

        if( imgdat != null )
        {
          int[] pixelsi= new int[w*h];

          for(int i=0;i<(w*h);i++)
          {
            int a=(int)(imgdat.pixels[4*i]);
            int r= (int)(imgdat.pixels[(4*i)+1]);
            int g= (int)(imgdat.pixels[(4*i)+2]);
            int b= (int)(imgdat.pixels[(4*i)+3]);
            pixelsi[i]=(((a<<24)&0xff000000 )|((r<<16)&0x00ff0000 ) |
                        ((g<<8)&0x0000ff00 )|(b &0x000000ff ));	

          }// end of for

          img= createImage(new MemoryImageSource(w, h, pixelsi, 0, w));

		}//  end of if	

      } catch (IOException e)
        {  //System.out.println("IOException is raised! ");
           //e.printStackTrace();
        }
	
    }// end of receive()	

    public void
    stop()
    {
       System.out.println(" I will be STOPPED ");

      if(runner!=null)
      {
         runner.stop();
         runner=null;
      }


     try
     {  s.close();
     } catch(IOException e)
       {  //System.out.println(e);
          //e.printStackTrace();
       }

       dispose();

    }// end of stop()
		
}// end of class OutputApplet



