
package webflow.util;

import java.lang.Exception;

/*
* When you try to add a QueueItem object which is
* different from the already added objects then
* you will get this exception. A Queue has to have
* only one kind of QueueItem objects. This class
* is decided when you add the first element.
*/
public class 
NotAllowableQueueItemException extends Exception
{

  public 
  NotAllowableQueueItemException()
  { super("QueueItem object is not correct "); }

}// end of class NotAllowableQueueItemException
